<?php
//增加留言分类
function AddGbookClass($add,$do=0,$userid,$username){
	global $empire,$dbtbpre;
	if(empty($add[bname]))
	{
		printerror("EmptyGbookClass","history.go(-1)");
    }
	if(empty($do))
	{
		$add['checked']=(int)$add['checked'];
		$add['groupid']=(int)$add['groupid'];
		$level="gbook";
		$table="{$dbtbpre}enewsgbookclass";
		$location="GbookClass.php";
		$mychecked=",checked,groupid";
		$mycheckedvalue=",".$add['checked'].",".$add['groupid'];
	}
	else
	{
		$level="feedback";
		$table="{$dbtbpre}enewsfeedbackclass";
		$location="FeedbackClass.php";
		$mychecked="";
		$mycheckedvalue="";
	}
	//验证权限
	CheckLevel($userid,$username,$classid,$level);
	$sql=$empire->query("insert into ".$table."(bname".$mychecked.") values('$add[bname]'".$mycheckedvalue.");");
	if($sql)
	{
		$bid=$empire->lastid();
		//操作日志
		insert_dolog("bid=".$bid."<br>bname=".$add[bname]);
		printerror("AddGbookClassSuccess",$location);
    }
	else
	{printerror("DbError","history.go(-1)");}
}

//修改留言分类
function EditGbookClass($add,$do=0,$userid,$username){
	global $empire,$dbtbpre;
	if(empty($add[bname])||!$add[bid])
	{
		printerror("EmptyGbookClass","history.go(-1)");
    }
	if(empty($do))
	{
		$add['checked']=(int)$add['checked'];
		$add['groupid']=(int)$add['groupid'];
		$level="gbook";
		$table="{$dbtbpre}enewsgbookclass";
		$location="GbookClass.php";
		$mychecked=",checked=".$add['checked'].",groupid=".$add['groupid'];
	}
	else
	{
		$level="feedback";
		$table="{$dbtbpre}enewsfeedbackclass";
		$location="FeedbackClass.php";
		$mychecked="";
	}
	//验证权限
	CheckLevel($userid,$username,$classid,$level);
	$sql=$empire->query("update ".$table." set bname='$add[bname]'".$mychecked." where bid='$add[bid]';");
	if($sql)
	{
		//操作日志
		insert_dolog("bid=".$add[bid]."<br>bname=".$add[bname]);
		printerror("EditGbookClassSuccess",$location);
    }
	else
	{printerror("DbError","history.go(-1)");}
}

//删除留言分类
function DelGbookClass($bid,$do=0,$userid,$username){
	global $empire,$dbtbpre;
	$bid=(int)$bid;
	if(!$bid)
	{
		printerror("NotChangeGbookClassid","history.go(-1)");
    }
	if(empty($do))
	{
		$level="gbook";
		$table="{$dbtbpre}enewsgbookclass";
		$tabledata="{$dbtbpre}enewsgbook";
		$location="GbookClass.php";
	}
	else
	{
		$level="feedback";
		$table="{$dbtbpre}enewsfeedbackclass";
		$tabledata="{$dbtbpre}enewsfeedback";
		$location="FeedbackClass.php";
	}
	//验证权限
	CheckLevel($userid,$username,$classid,$level);
	$r=$empire->fetch1("select bname from ".$table." where bid='$bid';");
	$sql=$empire->query("delete from ".$table." where bid='$bid';");
	$sql1=$empire->query("delete from ".$tabledata." where bid='$bid';");
	if($sql)
	{
		//操作日志
		insert_dolog("bid=".$bid."<br>bname=".$r[bname]);
		printerror("DelGbookClassSuccess",$location);
    }
	else
	{printerror("DbError","history.go(-1)");}
}

//---------返回留言/反馈分类
function ReturnGbookClass($bid,$do=0){
	global $empire,$dbtbpre;
	$bid=(int)$bid;
	if(empty($do))
	{
		$table="{$dbtbpre}enewsgbookclass";
	}
	else
	{
		$table="{$dbtbpre}enewsfeedbackclass";
	}
	$sql=$empire->query("select bid,bname from ".$table." order by bid");
	while($r=$empire->fetch($sql))
	{
		if($bid==$r[bid])
		{$selected=" selected";}
		else
		{$selected="";}
		$select.="<option value=".$r[bid].$selected.">".$r[bname]."</option>";
	}
	return $select;
}

//回复留言板
function ReGbook($lyid,$retext,$bid,$userid,$username){
	global $empire,$dbtbpre;
	$lyid=(int)$lyid;
	$bid=(int)$bid;
	if(!$lyid||!$retext)
	{
		printerror("EmptyReGbooktext","history.go(-1)");
    }
	//验证权限
	CheckLevel($userid,$username,$classid,"gbook");
	$sql=$empire->query("update {$dbtbpre}enewsgbook set retext='$retext' where lyid='$lyid';");
	if($sql)
	{
		//操作日志
		insert_dolog("lyid=".$lyid);
		echo"<script>opener.parent.main.location.href='gbook.php?bid=$bid';window.close();</script>";
		exit();
	}
	else
	{printerror("DbError","history.go(-1)");}
}

//删除留言
function DelGbook($lyid,$bid,$userid,$username){
	global $empire,$dbtbpre;
	$lyid=(int)$lyid;
	$bid=(int)$bid;
	if(!$lyid)
	{
		printerror("NotChangeLyid","history.go(-1)");
    }
	//验证权限
	CheckLevel($userid,$username,$classid,"gbook");
	$sql=$empire->query("delete from {$dbtbpre}enewsgbook where lyid='$lyid';");
	if($sql)
	{
		//操作日志
		insert_dolog("lyid=".$lyid);
		printerror("DelGbookSuccess","gbook.php?bid=$bid");
	}
	else
	{printerror("DbError","history.go(-1)");}
}

//--------------------------批量删除留言(3.6)
function DelGbook_all($lyid,$bid,$userid,$username){
	global $empire,$dbtbpre;
	//验证权限
	CheckLevel($userid,$username,$classid,"gbook");
	$bid=(int)$bid;
	$count=count($lyid);
	if(empty($count))
	{printerror("NotChangeLyid","history.go(-1)");}
	for($i=0;$i<$count;$i++)
	{
		$add.="lyid='$lyid[$i]' or ";
	}
	$add=substr($add,0,strlen($add)-4);
	$sql=$empire->query("delete from {$dbtbpre}enewsgbook where ".$add);
	if($sql)
	{
		//操作日志
		insert_dolog("");
		printerror("DelGbookSuccess","gbook.php?bid=$bid");
	}
	else
	{printerror("DbError","history.go(-1)");}
}

//--------------------------批量审核留言(3.6)
function CheckGbook_all($lyid,$bid,$userid,$username){
	global $empire,$dbtbpre;
	//验证权限
	CheckLevel($userid,$username,$classid,"gbook");
	$bid=(int)$bid;
	$count=count($lyid);
	if(empty($count))
	{printerror("NotChangeCheckLyid","history.go(-1)");}
	for($i=0;$i<$count;$i++)
	{
		$add.="lyid='$lyid[$i]' or ";
	}
	$add=substr($add,0,strlen($add)-4);
	$sql=$empire->query("update {$dbtbpre}enewsgbook set checked=0 where ".$add);
	if($sql)
	{
		//操作日志
		insert_dolog("");
		printerror("CheckLysuccess","gbook.php?bid=$bid");
	}
	else
	{printerror("DbError","history.go(-1)");}
}

//删除反馈附件
function DelFeedbackFile($filename,$filepath){
	global $empire,$dbtbpre;
	if($filename)
	{
		$path="../../../d/file/p/".$filepath."/";
		$filer=explode(",",$filename);
		$fcount=count($filer);
		for($j=0;$j<$fcount;$j++)
		{
			DelFiletext($path.$filer[$j]);
			$where.=$or."filename='".$filer[$j]."'";
			$or=" or ";
		}
		$delsql=$empire->query("delete from {$dbtbpre}enewsfile where path='$filepath' and (".$where.")");
	}
}

//删除反馈信息
function DelFeedback($id,$bid,$userid,$username){
	global $empire,$dbtbpre;
	$id=(int)$id;
	$bid=(int)$bid;
	if(!$id)
	{
		printerror("NotChangeFeedbackid","history.go(-1)");
    }
	//验证权限
	//CheckLevel($userid,$username,$classid,"feedback");
	$r=$empire->fetch1("select id,title,filepath,filename from {$dbtbpre}enewsfeedback where id='$id';");
	if(!$r['id'])
	{
		printerror("NotChangeFeedbackid","history.go(-1)");
    }
	$sql=$empire->query("delete from {$dbtbpre}enewsfeedback where id='$id';");
	//删除附件
	DelFeedbackFile($r['filename'],$r['filepath']);
	if($sql)
	{
		//操作日志
		insert_dolog("id=".$id."<br>title=$r[title]");
		printerror("DelFeedbackSuccess","feedback.php?bid=$bid");
	}
	else
	{printerror("DbError","history.go(-1)");}
}

//批量删除反馈信息
function DelFeedback_all($id,$bid,$userid,$username){
	global $empire,$dbtbpre;
	$bid=(int)$bid;
	$count=count($id);
	if(!$count)
	{
		printerror("NotChangeFeedbackid","history.go(-1)");
    }
	$dh="";
	for($i=0;$i<$count;$i++)
	{
		$inid.=$dh.$id[$i];
		$dh=",";
		//删除附件
		$r=$empire->fetch1("select id,filepath,filename from {$dbtbpre}enewsfeedback where id='".$id[$i]."';");
		DelFeedbackFile($r['filename'],$r['filepath']);
	}
	$sql=$empire->query("delete from {$dbtbpre}enewsfeedback where id in (".$inid.");");
	if($sql)
	{
		//操作日志
		insert_dolog("");
		printerror("DelFeedbackSuccess","feedback.php?bid=$bid");
	}
	else
	{printerror("DbError","history.go(-1)");}
}

//增加反馈字段
function AddFeedbackF($add,$userid,$username){
	global $empire,$dbtbpre;
	$add[f]=RepPostVar($add[f]);
	if(empty($add[f])||empty($add[fname]))
	{printerror("EmptyF","history.go(-1)");}
	//验证权限
	//CheckLevel($userid,$username,$classid,"feedbackf");
	//字段是否重复
	$s=$empire->query("SHOW FIELDS FROM {$dbtbpre}enewsfeedback");
	$b=0;
	while($r=$empire->fetch($s))
	{
		if($r[Field]==$add[f])
		{
			$b=1;
			break;
		}
    }
	if($b)
	{printerror("ReF","history.go(-1)");}
	//字段类型
	if($add[ftype]=="TINYINT"||$add[ftype]=="SMALLINT"||$add[ftype]=="INT"||$add[ftype]=="BIGINT"||$add[ftype]=="FLOAT"||$add[ftype]=="DOUBLE")
	{
		$def=" default '0'";
	}
	elseif($add[ftype]=="VARCHAR")
	{
		$def=" default ''";
	}
	else
	{
		$def="";
	}
	$type=$add[ftype];
	//VARCHAR
	if($add[ftype]=='VARCHAR'&&empty($add[flen]))
	{
		$add[flen]='255';
	}
	//字段长度
	if($add[flen])
	{
		if($add[ftype]!="TEXT"&&$add[ftype]!="MEDIUMTEXT"&&$add[ftype]!="LONGTEXT")
		{
			$type.="(".$add[flen].")";
		}
	}
	$field="`".$add[f]."` ".$type." NOT NULL".$def;
	//新增字段
	$asql=$empire->query("alter table {$dbtbpre}enewsfeedback add ".$field);
	//处理变量
	$add[myorder]=(int)$add[myorder];
	$sql=$empire->query("insert into {$dbtbpre}enewsfeedbackf(f,fname,fform,fzs,myorder,ftype,flen,fformsize) values('$add[f]','$add[fname]','$add[fform]','".addslashes($add[fzs])."',$add[myorder],'$add[ftype]','$add[flen]','$add[fformsize]');");
	$lastid=$empire->lastid();
	if($asql&&$sql)
	{
		//操作日志
		insert_dolog("fid=".$lastid."<br>f=".$add[f]);
		printerror("AddFSuccess","AddFeedbackF.php?enews=AddFeedbackF");
	}
	else
	{
		printerror("DbError","history.go(-1)");
	}
}

//修改反馈字段
function EditFeedbackF($add,$userid,$username){
	global $empire,$dbtbpre;
	$fid=(int)$add['fid'];
	$add[f]=RepPostVar($add[f]);
	$add[oldf]=RepPostVar($add[oldf]);
	if(empty($add[f])||empty($add[fname])||!$fid)
	{printerror("EmptyF","history.go(-1)");}
	//验证权限
	//CheckLevel($userid,$username,$classid,"feedbackf");
	if($add[f]<>$add[oldf])
	{
		//字段是否重复
		$s=$empire->query("SHOW FIELDS FROM {$dbtbpre}enewsfeedback");
		$b=0;
		while($r=$empire->fetch($s))
		{
			if($r[Field]==$add[f])
			{
				$b=1;
				break;
			}
		}
		if($b)
		{printerror("ReF","history.go(-1)");}
	}
	//字段类型
	if($add[ftype]=="TINYINT"||$add[ftype]=="SMALLINT"||$add[ftype]=="INT"||$add[ftype]=="BIGINT"||$add[ftype]=="FLOAT"||$add[ftype]=="DOUBLE")
	{
		$def=" default '0'";
	}
	elseif($add[ftype]=="VARCHAR")
	{
		$def=" default ''";
	}
	else
	{
		$def="";
	}
	$type=$add[ftype];
	//VARCHAR
	if($add[ftype]=='VARCHAR'&&empty($add[flen]))
	{
		$add[flen]='255';
	}
	//字段长度
	if($add[flen])
	{
		if($add[ftype]!="TEXT"&&$add[ftype]!="MEDIUMTEXT"&&$add[ftype]!="LONGTEXT")
		{
			$type.="(".$add[flen].")";
		}
	}
	$field="`".$add[f]."` ".$type." NOT NULL".$def;
	$usql=$empire->query("alter table {$dbtbpre}enewsfeedback change `".$add[oldf]."` ".$field);
	//处理变量
	$add[myorder]=(int)$add[myorder];
	$sql=$empire->query("update {$dbtbpre}enewsfeedbackf set f='$add[f]',fname='$add[fname]',fform='$add[fform]',fzs='".addslashes($add[fzs])."',myorder=$add[myorder],ftype='$add[ftype]',flen='$add[flen]',fformsize='$add[fformsize]' where fid=$fid");
	//字段名更换
	if($add[f]<>$add[oldf])
	{
		$record="<!--record-->";
		$field="<!--field--->";
		$like=$field.$add[oldf].$record;
		$newlike=$field.$add[f].$record;
		$slike=",".$add[oldf].",";
		$newslike=",".$add[f].",";
		$csql=$empire->query("select bid,enter,mustenter,filef from {$dbtbpre}enewsfeedbackclass where enter like '%$like%'");
		while($cr=$empire->fetch($csql))
		{
			$setf="";
			if(strstr($cr['mustenter'],$slike))
			{
				$setf.=",mustenter=REPLACE(mustenter,'$slike','$newslike')";
			}
			if(strstr($cr['filef'],$slike))
			{
				$setf.=",filef=REPLACE(filef,'$slike','$newslike')";
			}
			$cusql=$empire->query("update {$dbtbpre}enewsfeedbackclass set enter=REPLACE(enter,'$like','$newlike')".$setf." where bid='$cr[bid]'");
		}
	}
	if($usql&&$sql)
	{
		//操作日志
		insert_dolog("fid=".$fid."<br>f=".$add[f]);
		printerror("EditFSuccess","ListFeedbackF.php");
	}
	else
	{printerror("DbError","history.go(-1)");}
}

//删除反馈字段
function DelFeedbackF($add,$userid,$username){
	global $empire,$dbtbpre;
	$fid=(int)$add['fid'];
	if(empty($fid))
	{printerror("EmptyFid","history.go(-1)");}
	//验证权限
	//CheckLevel($userid,$username,$classid,"feedbackf");
	$r=$empire->fetch1("select f from {$dbtbpre}enewsfeedbackf where fid=$fid");
	if(!$r[f])
	{
		printerror("EmptyFid","history.go(-1)");
	}
	if($r[f]=="title")
	{
		printerror("NotIsAdd","history.go(-1)");
	}
	$usql=$empire->query("alter table {$dbtbpre}enewsfeedback drop COLUMN `".$r[f]."`");
	$sql=$empire->query("delete from {$dbtbpre}enewsfeedbackf where fid=$fid");
	//更新分类表
	$record="<!--record-->";
	$field="<!--field--->";
	$like=$field.$r[f].$record;
	$slike=",".$r[f].",";
	$csql=$empire->query("select bid,enter,mustenter,filef from {$dbtbpre}enewsfeedbackclass where enter like '%$like%'");
	while($cr=$empire->fetch($csql))
	{
		$setf="";
		if(strstr($cr['mustenter'],$slike))
		{
			$setf.=",mustenter=REPLACE(mustenter,'$slike',',')";
		}
		if(strstr($cr['filef'],$slike))
		{
			$setf.=",filef=REPLACE(filef,'$slike',',')";
		}
		//录入项
		$enter="";
		$re1=explode($record,$cr[enter]);
		for($i=0;$i<count($re1)-1;$i++)
		{
			if(strstr($re1[$i],$like))
			{continue;}
			$enter.=$re1[$i].$record;
		}
		$cusql=$empire->query("update {$dbtbpre}enewsfeedbackclass set enter='$enter'".$setf." where bid='$cr[bid]'");
	}
	if($usql&&$sql)
	{
		//操作日志
		insert_dolog("fid=".$fid."<br>f=".$r[f]);
		printerror("DelFSuccess","ListFeedbackF.php");
	}
	else
	{printerror("DbError","history.go(-1)");}
}

//修改反馈字段顺序
function EditFeedbackFOrder($fid,$myorder,$userid,$username){
	global $empire,$dbtbpre;
	//验证权限
	//CheckLevel($userid,$username,$classid,"feedbackf");
	for($i=0;$i<count($myorder);$i++)
	{
		$newmyorder=(int)$myorder[$i];
		$usql=$empire->query("update {$dbtbpre}enewsfeedbackf set myorder=$newmyorder where fid='$fid[$i]'");
    }
	printerror("EditFOrderSuccess","ListFeedbackF.php");
}

//自动生成反馈表单
function ReturnFeedbackBtemp($cname,$center,$mustenter){
	global $empire,$dbtbpre,$fun_r;
	//表单元素
	$temp="<tr><td width='16%' height=25 bgcolor='ffffff'>enews.name</td><td bgcolor='ffffff'>enews.var</td></tr>";
	for($i=0;$i<count($center);$i++)
	{
		$v=$center[$i];
		$fr=$empire->fetch1("select fform,fformsize from {$dbtbpre}enewsfeedbackf where f='$v' limit 1");
		if($fr['fform']=="file")
		{
			$fsize=$fr[fformsize]?" size='".$fr[fformsize]."'":"";
			$repform="<input type='file' name='".$v."'".$fsize.">";
		}
		elseif($fr['fform']=="textarea")
		{
			$fsr=explode(',',$fr[fformsize]);
			$cols=$fsr[0]?$fsr[0]:60;
			$rows=$fsr[1]?$fsr[1]:12;
			$repform="<textarea name='".$v."' cols='".$cols."' rows='".$rows."'></textarea>";
		}
		else
		{
			$fsize=$fr[fformsize]?" size='".$fr[fformsize]."'":"";
			$repform="<input name='".$v."' type='text'".$fsize.">";
		}
		//必填
		$star="";
		if(strstr($mustenter,",".$v.","))
		{
			$star="(*)";
		}
		$data.=str_replace("enews.var",$repform.$star,str_replace("enews.name",$cname[$v],$temp));
    }
	return "[!--cp.header--]<table width=100% align=center cellpadding=3 cellspacing=1 bgcolor='#DBEAF5'><form name='feedback' method='post' enctype='multipart/form-data' action='../../enews/index.php'><input name='enews' type='hidden' value='AddFeedback'>".$data."<tr><td bgcolor='ffffff'></td><td bgcolor='ffffff'><input type='submit' name='submit' value='".$fun_r['onsubmit']."'></td></tr></form></table>[!--cp.footer--]";
}

//生成反馈表单文件
function ReFeedbackClassFile($bid){
	global $empire,$dbtbpre;
	$r=$empire->fetch1("select btemp from {$dbtbpre}enewsfeedbackclass where bid='$bid'");
	//替换公共变量
	$btemp=ReplaceTempvar($r['btemp']);
	$btemp=str_replace("[!--cp.header--]","<? include(\"../../data/template/cp_1.php\");?>",$btemp);
	$btemp=str_replace("[!--cp.footer--]","<? include(\"../../data/template/cp_2.php\");?>",$btemp);
	$file="../../tool/feedback/temp/feedback".$bid.".php";
	$btemp="<?
if(!defined('InEmpireCMS'))
{exit();}
?>".$btemp;
	WriteFiletext($file,$btemp);
}

//批量生成反馈表单文件
function ReMoreFeedbackClassFile($start=0,$userid,$username){
	global $empire,$dbtbpre;
	//验证权限
	CheckLevel($userid,$username,$classid,"changedata");
	$sql=$empire->query("select bid from {$dbtbpre}enewsfeedbackclass order by bid");
	while($r=$empire->fetch($sql))
	{
		ReFeedbackClassFile($r['bid']);
	}
	printerror("ReMFeedbackFileSuccess","");
}

//增加反馈分类
function AddFeedbackClass($add,$userid,$username){
	global $empire,$dbtbpre;
	if(empty($add[bname]))
	{printerror("EmptyGbookClass","history.go(-1)");}
	//验证权限
	//CheckLevel($userid,$username,$classid,"feedbackf");
	$enter=TogMqenter($add['cname'],$add['center']);
	$mustenter=TogMustf($add['cname'],$add['menter']);
	$filef=ReturnMFileF($enter,$dbtbpre."enewsfeedbackf",0,"file");
	//自动生成表单
	if($add[btype])
	{
		$add[btemp]=ReturnFeedbackBtemp($add['cname'],$add['center'],$mustenter);
	}
	$groupid=(int)$add['groupid'];
	$sql=$empire->query("insert into {$dbtbpre}enewsfeedbackclass(bname,btemp,bzs,enter,mustenter,filef,groupid) values('$add[bname]','".addslashes($add[btemp])."','".addslashes($add[bzs])."','$enter','$mustenter','$filef',$groupid);");
	$bid=$empire->lastid();
	//生成表单页面
	ReFeedbackClassFile($bid);
	if($sql)
	{
		//操作日志
	    insert_dolog("bid=".$bid."<br>bname=".$add[bname]);
		printerror("AddGbookClassSuccess","AddFeedbackClass.php?enews=AddFeedbackClass");
	}
	else
	{printerror("DbError","history.go(-1)");}
}

//修改反馈分类
function EditFeedbackClass($add,$userid,$username){
	global $empire,$dbtbpre;
	$bid=(int)$add['bid'];
	if(empty($add[bname])||!$bid)
	{printerror("EmptyGbookClass","history.go(-1)");}
	//验证权限
	//CheckLevel($userid,$username,$classid,"feedbackf");
	$enter=TogMqenter($add['cname'],$add['center']);
	$mustenter=TogMustf($add['cname'],$add['menter']);
	$filef=ReturnMFileF($enter,$dbtbpre."enewsfeedbackf",0,"file");
	//自动生成表单
	if($add[btype])
	{
		$add[btemp]=ReturnFeedbackBtemp($add['cname'],$add['center'],$mustenter);
	}
	$groupid=(int)$add['groupid'];
	$sql=$empire->query("update {$dbtbpre}enewsfeedbackclass set bname='$add[bname]',btemp='".addslashes($add[btemp])."',bzs='".addslashes($add[bzs])."',enter='$enter',mustenter='$mustenter',filef='$filef',groupid=$groupid where bid=$bid");
	//生成表单页面
	ReFeedbackClassFile($bid);
	if($sql)
	{
		//操作日志
	    insert_dolog("bid=".$bid."<br>bname=".$add[bname]);
		printerror("EditGbookClassSuccess","FeedbackClass.php");
	}
	else
	{printerror("DbError","history.go(-1)");}
}

//删除反馈分类
function DelFeedbackClass($add,$userid,$username){
	global $empire,$dbtbpre;
	$bid=(int)$add['bid'];
	if(!$bid)
	{printerror("NotChangeGbookClassid","history.go(-1)");}
	//验证权限
	//CheckLevel($userid,$username,$classid,"feedbackf");
	$r=$empire->fetch1("select bid,bname from {$dbtbpre}enewsfeedbackclass where bid=$bid;");
	if(!$r['bid'])
	{printerror("NotChangeGbookClassid","history.go(-1)");}
	$sql=$empire->query("delete from {$dbtbpre}enewsfeedbackclass where bid=$bid;");
	//删除附件
	$fsql=$empire->query("select id,filepath,filename from {$dbtbpre}enewsfeedback where bid=$bid");
	while($fr=$empire->fetch($fsql))
	{
		DelFeedbackFile($fr['filename'],$fr['filepath']);
	}
	$sql1=$empire->query("delete from {$dbtbpre}enewsfeedback where bid=$bid;");
	//删除表单文件
	$file="../../tool/feedback/temp/feedback".$bid.".php";
	DelFiletext($file);
	if($sql)
	{
		//操作日志
	    insert_dolog("bid=".$bid."<br>bname=".$r[bname]);
		printerror("DelGbookClassSuccess","FeedbackClass.php");
	}
	else
	{printerror("DbError","history.go(-1)");}
}

//-------------------------------------------ecms3.6--------------
//---------------删除单个报告
function DelError($errorid,$userid,$username){
	global $empire,$dbtbpre;
	//验证权限
	CheckLevel($userid,$username,$classid,"downerror");
	$errorid=(int)$errorid;
	if(empty($errorid))
	{
		printerror("EmptyDelErrorid","history.go(-1)");
    }
	$sql=$empire->query("delete from {$dbtbpre}enewsdownerror where errorid='$errorid'");
	if($sql)
	{
		//操作日志
		insert_dolog("errorid=$errorid");
		printerror("DelErrorSuccess","ListError.php");
	}
	else
	{
		printerror("DbError","history.go(-1)");
	}
}

//--------------------------批量删除报告
function DelError_all($errorid,$userid,$username){
	global $empire,$dbtbpre;
	//验证权限
	CheckLevel($userid,$username,$classid,"downerror");
	$count=count($errorid);
	if(empty($count))
	{printerror("EmptyDelErrorid","history.go(-1)");}
	for($i=0;$i<$count;$i++)
	{
		$add.="errorid='$errorid[$i]' or ";
	}
	$add=substr($add,0,strlen($add)-4);
	$sql=$empire->query("delete from {$dbtbpre}enewsdownerror where ".$add);
	if($sql)
	{
		//操作日志
		insert_dolog("");
		printerror("DelErrorSuccess","ListError.php");
	}
	else
	{printerror("DbError","history.go(-1)");}
}

//-------------------------增加采集随机字符
function AddNotcj($add,$userid,$username){
	global $empire,$dbtbpre;
	//验证权限
	CheckLevel($userid,$username,$classid,"notcj");
	if(empty($add[word]))
	{
		printerror("EmptyNotcjWord","history.go(-1)");
    }
	$word=RepPhpAspJspcode($add[word]);
	$sql=$empire->query("insert into {$dbtbpre}enewsnotcj(word) values('".addslashes($word)."');");
	$id=$empire->lastid();
	GetNotcj();
	if($sql)
	{
		//操作日志
		insert_dolog("id=$id");
		printerror("AddNotcjSuccess","NotCj.php");
    }
	else
	{
		printerror("DbError","history.go(-1)");
    }
}

//-------------------------修改采集随机字符
function EditNotcj($add,$userid,$username){
	global $empire,$dbtbpre;
	//验证权限
	CheckLevel($userid,$username,$classid,"notcj");
	$id=(int)$add['id'];
	if(empty($add[word])||!$id)
	{
		printerror("EmptyNotcjWord","history.go(-1)");
    }
	$word=RepPhpAspJspcode($add[word]);
	$sql=$empire->query("update {$dbtbpre}enewsnotcj set word='".addslashes($word)."' where id='$id'");
	GetNotcj();
	if($sql)
	{
		//操作日志
		insert_dolog("id=$id");
		printerror("EditNotcjSuccess","NotCj.php");
    }
	else
	{
		printerror("DbError","history.go(-1)");
    }
}

//-------------------------删除采集随机字符
function DelNotcj($id,$userid,$username){
	global $empire,$dbtbpre;
	//验证权限
	CheckLevel($userid,$username,$classid,"notcj");
	$id=(int)$id;
	if(!$id)
	{
		printerror("EmptyDelNotcjid","history.go(-1)");
    }
	$sql=$empire->query("delete from {$dbtbpre}enewsnotcj where id='$id'");
	GetNotcj();
	if($sql)
	{
		//操作日志
		insert_dolog("id=$id");
		printerror("DelNotcjSuccess","NotCj.php");
    }
	else
	{
		printerror("DbError","history.go(-1)");
    }
}

//-----------------------生成随机字符缓存
function GetNotcj(){
	global $empire,$dbtbpre;
	$file="../../class/notcj.php";
	$sql=$empire->query("select id,word from {$dbtbpre}enewsnotcj");
	$i=0;
	while($r=$empire->fetch($sql))
	{
		$i++;
		$str.="\$notcj_r[$i]=\"".addslashes(stripSlashes($r[word]))."\";
	";
    }
	$string="<?php
	".$str."\$notcjnum=".$i.";
	?>";
	WriteFiletext_n($file,$string);
}

//-----------------------批量替换模板字符
function DoRepTemp($add,$userid,$username){
	global $empire,$dbtbpre;
	//验证权限
	CheckLevel($userid,$username,$classid,"template");
	$oldword=RepPhpAspJspcode(addslashes($add['oldword']));
	$newword=RepPhpAspJspcode(addslashes($add['newword']));
	if(!$oldword)
	{
		printerror("EmptyRepTemp","history.go(-1)");
    }
	$gid=(int)$add['gid'];
	//首页模板
	if($add['indextemp'])
	{
		$isql=$empire->query("update ".GetDoTemptb("enewspubtemp",$gid)." set indextemp=REPLACE(indextemp,'".$oldword."','".$newword."') limit 1");
    }
	//修改栏目封面模板
	if($add['classtemp'])
	{
		$csql=$empire->query("update ".GetDoTemptb("enewsclasstemp",$gid)." set temptext=REPLACE(temptext,'".$oldword."','".$newword."')");
    }
	//修改标签模板
	if($add['zttemp'])
	{
		$bqsql=$empire->query("update ".GetDoTemptb("enewsbqtemp",$gid)." set temptext=REPLACE(temptext,'".$oldword."','".$newword."'),listvar=REPLACE(listvar,'".$oldword."','".$newword."')");
    }
	//修改列表模板
	if($add['listtemp'])
	{
		$lsql=$empire->query("update ".GetDoTemptb("enewslisttemp",$gid)." set temptext=REPLACE(temptext,'".$oldword."','".$newword."'),listvar=REPLACE(listvar,'".$oldword."','".$newword."')");
    }
	//修改内容模板
	if($add['newstemp'])
	{
		$nsql=$empire->query("update ".GetDoTemptb("enewsnewstemp",$gid)." set temptext=REPLACE(temptext,'".$oldword."','".$newword."')");
	}
	//修改搜索模板
	if($add['searchtemp'])
	{
		$ssql=$empire->query("update ".GetDoTemptb("enewssearchtemp",$gid)." set temptext=REPLACE(temptext,'".$oldword."','".$newword."'),listvar=REPLACE(listvar,'".$oldword."','".$newword."')");
	}
	//修改自定义页面
	if($add['userpage'])
	{
		$usql=$empire->query("update {$dbtbpre}enewspage set pagetext=REPLACE(pagetext,'".$oldword."','".$newword."')");
	}
	//评论列表模板
	if($add['pltemp'])
	{
		$psql=$empire->query("update ".GetDoTemptb("enewspubtemp",$gid)." set pllisttemp=REPLACE(pllisttemp,'".$oldword."','".$newword."') limit 1");
    }
	//控制面板模板
	if($add['cptemp'])
	{
		$psql=$empire->query("update ".GetDoTemptb("enewspubtemp",$gid)." set cptemp=REPLACE(cptemp,'".$oldword."','".$newword."') limit 1");
    }
	//搜索表单模板
	if($add['sformtemp'])
	{
		$psql=$empire->query("update ".GetDoTemptb("enewspubtemp",$gid)." set searchtemp=REPLACE(searchtemp,'".$oldword."','".$newword."') limit 1");
    }
	//打印模板
	if($add['printtemp'])
	{
		$printsql=$empire->query("update ".GetDoTemptb("enewspubtemp",$gid)." set printtemp=REPLACE(printtemp,'".$oldword."','".$newword."') limit 1");
    }
	//模板变量
	if($add['tempvar'])
	{
		$usql=$empire->query("update ".GetDoTemptb("enewstempvar",$gid)." set varvalue=REPLACE(varvalue,'".$oldword."','".$newword."')");
	}
	//留言板模板
	if($add['gbooktemp'])
	{
		$gbooksql=$empire->query("update ".GetDoTemptb("enewspubtemp",$gid)." set gbooktemp=REPLACE(gbooktemp,'".$oldword."','".$newword."') limit 1");
    }
	//登陆状态模板
	if($add['loginiframe'])
	{
		$loginiframesql=$empire->query("update ".GetDoTemptb("enewspubtemp",$gid)." set loginiframe=REPLACE(loginiframe,'".$oldword."','".$newword."') limit 1");
    }
	//修改投票模板
	if($add['votetemp'])
	{
		$csql=$empire->query("update ".GetDoTemptb("enewsvotetemp",$gid)." set temptext=REPLACE(temptext,'".$oldword."','".$newword."')");
    }
	//反馈表单模板
	if($add['feedbackbtemp'])
	{
		$usql=$empire->query("update {$dbtbpre}enewsfeedbackclass set btemp=REPLACE(btemp,'".$oldword."','".$newword."')");
	}
	//操作日志
	insert_dolog("gid=$gid");
	printerror("RepTempSuccess","history.go(-1)");
}

//增加js模板
function AddJstemp($add,$userid,$username){
	global $empire,$dbtbpre;
	if(!$add[tempname]||!$add[temptext])
	{
		printerror("EmptyJstempname","history.go(-1)");
    }
	//验证权限
	CheckLevel($userid,$username,$classid,"template");
	$classid=(int)$add['classid'];
	$add[temptext]=str_replace("\r\n","",$add[temptext]);
	$gid=(int)$add['gid'];
	$sql=$empire->query("insert into ".GetDoTemptb("enewsjstemp",$gid)."(tempname,temptext,classid,showdate) values('$add[tempname]','".addslashes($add[temptext])."',$classid,'$add[showdate]');");
	if($sql)
	{
		$tempid=$empire->lastid();
		//操作日志
		insert_dolog("tempid=$tempid&tempname=$add[tempname]&gid=$gid");
		printerror("AddJstempSuccess","AddJstemp.php?enews=AddJstemp&gid=$gid");
	}
	else
	{
		printerror("DbError","history.go(-1)");
	}
}

//修改js模板
function EditJstemp($add,$userid,$username){
	global $empire,$dbtbpre;
	$tempid=(int)$add['tempid'];
	if(!$tempid||!$add[tempname]||!$add[temptext])
	{
		printerror("EmptyJstempname","history.go(-1)");
    }
	//验证权限
	CheckLevel($userid,$username,$classid,"template");
	$classid=(int)$add['classid'];
	$add[temptext]=str_replace("\r\n","",$add[temptext]);
	$gid=(int)$add['gid'];
	$sql=$empire->query("update ".GetDoTemptb("enewsjstemp",$gid)." set tempname='$add[tempname]',temptext='".addslashes($add[temptext])."',classid=$classid,showdate='$add[showdate]' where tempid=$tempid");
	if($sql)
	{
		//操作日志
		insert_dolog("tempid=$tempid&tempname=$add[tempname]&gid=$gid");
		printerror("EditJstempSuccess","ListJstemp.php?classid=$add[cid]&gid=$gid");
	}
	else
	{
		printerror("DbError","history.go(-1)");
	}
}

//删除js模板
function DelJstemp($add,$userid,$username){
	global $empire,$dbtbpre;
	$tempid=(int)$add['tempid'];
	if(!$tempid)
	{
		printerror("EmptyJstempid","history.go(-1)");
    }
	//验证权限
	CheckLevel($userid,$username,$classid,"template");
	$gid=(int)$add['gid'];
	$r=$empire->fetch1("select tempname from ".GetDoTemptb("enewsjstemp",$gid)." where tempid=$tempid");
	$sql=$empire->query("delete from ".GetDoTemptb("enewsjstemp",$gid)." where tempid=$tempid");
	if($sql)
	{
		//操作日志
		insert_dolog("tempid=$tempid&tempname=$r[tempname]&gid=$gid");
		printerror("DelJstempSuccess","ListJstemp.php?classid=$add[cid]&gid=$gid");
	}
	else
	{
		printerror("DbError","history.go(-1)");
	}
}

//设为默认js模板
function DefaultJstemp($add,$userid,$username){
	global $empire,$dbtbpre;
	$tempid=(int)$add['tempid'];
	if(!$tempid)
	{
		printerror("EmptyJstempid","history.go(-1)");
    }
	//验证权限
	CheckLevel($userid,$username,$classid,"template");
	$gid=(int)$add['gid'];
	$r=$empire->fetch1("select tempname from ".GetDoTemptb("enewsjstemp",$gid)." where tempid=$tempid");
	$usql=$empire->query("update ".GetDoTemptb("enewsjstemp",$gid)." set isdefault=0");
	$sql=$empire->query("update ".GetDoTemptb("enewsjstemp",$gid)." set isdefault=1 where tempid=$tempid");
	$psql=$empire->query("update {$dbtbpre}enewspublic set jstempid=$tempid");
	if($sql)
	{
		//操作日志
		insert_dolog("tempid=$tempid&tempname=$r[tempname]&gid=$gid");
		printerror("DefaultJstempSuccess","ListJstemp.php?classid=$add[cid]&gid=$gid");
	}
	else
	{
		printerror("DbError","history.go(-1)");
	}
}

//增加后台样式
function AddAdminstyle($add,$userid,$username){
	global $empire,$dbtbpre;
	$path=RepPathStr($add['path']);
	$path=(int)$path;
	if(empty($path)||empty($add['stylename']))
	{
		printerror("EmptyAdminStyle","history.go(-1)");
	}
	//验证权限
	CheckLevel($userid,$username,$classid,"adminstyle");
	//目录是否存在
	if(!file_exists("../adminstyle/".$path))
	{
		printerror("EmptyAdminStylePath","history.go(-1)");
	}
	$sql=$empire->query("insert into {$dbtbpre}enewsadminstyle(stylename,path,isdefault) values('$add[stylename]',$path,0);");
	if($sql)
	{
		$styleid=$empire->lastid();
		//操作日志
		insert_dolog("styleid=$styleid&stylename=$add[stylename]");
		printerror("AddAdminStyleSuccess","AdminStyle.php");
	}
	else
	{
		printerror("DbError","history.go(-1)");
	}
}

//修改后台样式
function EditAdminStyle($add,$userid,$username){
	global $empire,$dbtbpre;
	$styleid=(int)$add['styleid'];
	$path=RepPathStr($add['path']);
	$path=(int)$path;
	if(!$styleid||empty($path)||empty($add['stylename']))
	{
		printerror("EmptyAdminStyle","history.go(-1)");
	}
	//验证权限
	CheckLevel($userid,$username,$classid,"adminstyle");
	//目录是否存在
	if(!file_exists("../adminstyle/".$path))
	{
		printerror("EmptyAdminStylePath","history.go(-1)");
	}
	$sql=$empire->query("update {$dbtbpre}enewsadminstyle set stylename='$add[stylename]',path=$path where styleid=$styleid");
	if($sql)
	{
		//操作日志
		insert_dolog("styleid=$styleid&stylename=$add[stylename]");
		printerror("EditAdminStyleSuccess","AdminStyle.php");
	}
	else
	{
		printerror("DbError","history.go(-1)");
	}
}

//默认后台样式
function DefAdminStyle($styleid,$userid,$username){
	global $empire,$dbtbpre;
	$styleid=(int)$styleid;
	if(!$styleid)
	{
		printerror("EmptyAdminStyleid","history.go(-1)");
	}
	//验证权限
	CheckLevel($userid,$username,$classid,"adminstyle");
	$r=$empire->fetch1("select stylename,path from {$dbtbpre}enewsadminstyle where styleid=$styleid");
	$usql=$empire->query("update {$dbtbpre}enewsadminstyle set isdefault=0");
	$sql=$empire->query("update {$dbtbpre}enewsadminstyle set isdefault=1 where styleid=$styleid");
	$upsql=$empire->query("update {$dbtbpre}enewspublic set defadminstyle='$r[path]' limit 1");
	if($sql)
	{
		GetConfig();
		//操作日志
		insert_dolog("styleid=$styleid&stylename=$r[stylename]");
		printerror("DefAdminStyleSuccess","AdminStyle.php");
	}
	else
	{
		printerror("DbError","history.go(-1)");
	}
}

//删除后台样式
function DelAdminStyle($styleid,$userid,$username){
	global $empire,$dbtbpre;
	$styleid=(int)$styleid;
	if(!$styleid)
	{
		printerror("EmptyAdminStyleid","history.go(-1)");
	}
	//验证权限
	CheckLevel($userid,$username,$classid,"adminstyle");
	$r=$empire->fetch1("select stylename,path,isdefault from {$dbtbpre}enewsadminstyle where styleid=$styleid");
	if($r['isdefault'])
	{
		printerror("NotDelDefAdminStyle","history.go(-1)");
	}
	$sql=$empire->query("delete from {$dbtbpre}enewsadminstyle where styleid=$styleid");
	if($sql)
	{
		//操作日志
		insert_dolog("styleid=$styleid&stylename=$r[stylename]");
		printerror("DelAdminStyleSuccess","AdminStyle.php");
	}
	else
	{
		printerror("DbError","history.go(-1)");
	}
}

//增加投票模板
function AddVoteTemp($add,$userid,$username){
	global $empire,$dbtbpre;
	if(!$add[tempname]||!$add[temptext])
	{
		printerror("EmptyVoteTempname","history.go(-1)");
	}
	//验证权限
	CheckLevel($userid,$username,$classid,"template");
	$gid=(int)$add['gid'];
	$sql=$empire->query("insert into ".GetDoTemptb("enewsvotetemp",$gid)."(tempname,temptext) values('".$add[tempname]."','".addslashes($add[temptext])."');");
	$tempid=$empire->lastid();
	if($sql)
	{
		//操作日志
		insert_dolog("tempid=$tempid&tempname=$add[tempname]&gid=$gid");
		printerror("AddVoteTempSuccess","AddVotetemp.php?enews=AddVoteTemp&gid=$gid");
	}
	else
	{
		printerror("DbError","history.go(-1)");
	}
}

//修改投票模板
function EditVoteTemp($add,$userid,$username){
	global $empire,$dbtbpre;
	$tempid=(int)$add[tempid];
	if(!$tempid||!$add[tempname]||!$add[temptext])
	{
		printerror("EmptyVoteTempname","history.go(-1)");
	}
	//验证权限
	CheckLevel($userid,$username,$classid,"template");
	$gid=(int)$add['gid'];
	$sql=$empire->query("update ".GetDoTemptb("enewsvotetemp",$gid)." set tempname='".$add[tempname]."',temptext='".addslashes($add[temptext])."' where tempid='$tempid'");
	if($sql)
	{
		//操作日志
		insert_dolog("tempid=$tempid&tempname=$add[tempname]&gid=$gid");
		printerror("EditVoteTempSuccess","ListVotetemp.php?gid=$gid");
	}
	else
	{
		printerror("DbError","history.go(-1)");
	}
}

//删除投票模板
function DelVoteTemp($tempid,$userid,$username){
	global $empire,$dbtbpre;
	$tempid=(int)$tempid;
	if(empty($tempid))
	{
		printerror("NotChangeVoteTempid","history.go(-1)");
	}
	//验证权限
	CheckLevel($userid,$username,$classid,"template");
	$gid=(int)$_GET['gid'];
	$r=$empire->fetch1("select tempname from ".GetDoTemptb("enewsvotetemp",$gid)." where tempid=$tempid");
	$sql=$empire->query("delete from ".GetDoTemptb("enewsvotetemp",$gid)." where tempid=$tempid");
	if($sql)
	{
		//操作日志
		insert_dolog("tempid=$tempid&tempname=$r[tempname]&gid=$gid");
		printerror("DelVoteTempSuccess","ListVotetemp.php?gid=$gid");
	}
	else
	{
		printerror("DbError","history.go(-1)");
	}
}

//增加用户自定义js
function AddUserjs($add,$userid,$username){
	global $empire,$dbtbpre;
	$jstempid=(int)$add['jstempid'];
	if(!$add[jsname]||!$jstempid||!$add[jssql]||!$add[jsfilename])
	{
		printerror("EmptyUserJsname","history.go(-1)");
	}
	$query_first=substr($add['jssql'],0,7);
	if(!($query_first=="select "||$query_first=="SELECT "))
	{
		printerror("JsSqlError","history.go(-1)");
	}
	//验证权限
	CheckLevel($userid,$username,$classid,"userjs");
	$add[jssql]=ClearAddsData($add[jssql]);
	$add[substr]=(int)$add[substr];
	$sql=$empire->query("insert into {$dbtbpre}enewsuserjs(jsname,jssql,jstempid,jsfilename,substr) values('$add[jsname]','".addslashes($add[jssql])."',$jstempid,'$add[jsfilename]',$add[substr]);");
	//刷新js
	$add[jssql]=addslashes($add[jssql]);
	ReUserjs($add,"../");
	if($sql)
	{
		$jsid=$empire->lastid();
		//操作日志
		insert_dolog("jsid=$jsid&jsname=$add[jsname]");
		printerror("AddUserjsSuccess","AddUserjs.php?enews=AddUserjs");
	}
	else
	{
		printerror("DbError","history.go(-1)");
	}
}

//修改用户自定义js
function EditUserjs($add,$userid,$username)
{global $empire,$dbtbpre;
	$jsid=(int)$add['jsid'];
	$jstempid=(int)$add['jstempid'];
	if(!$jsid||!$add[jsname]||!$jstempid||!$add[jssql]||!$add[jsfilename])
	{
		printerror("EmptyUserJsname","history.go(-1)");
	}
	$query_first=substr($add['jssql'],0,7);
	if(!($query_first=="select "||$query_first=="SELECT "))
	{
		printerror("JsSqlError","history.go(-1)");
	}
	//验证权限
	CheckLevel($userid,$username,$classid,"userjs");
	//删除旧js文件
	if($add['oldjsfilename']<>$add['jsfilename'])
	{
		DelFiletext($add['oldjsfilename']);
	}
	$add[jssql]=ClearAddsData($add[jssql]);
	$add[substr]=(int)$add[substr];
	$sql=$empire->query("update {$dbtbpre}enewsuserjs set jsname='$add[jsname]',jssql='".addslashes($add[jssql])."',jstempid=$jstempid,jsfilename='$add[jsfilename]',substr=$add[substr] where jsid=$jsid");
	//刷新js
	$add[jssql]=addslashes($add[jssql]);
	ReUserjs($add,"../");
	if($sql)
	{
		//操作日志
	    insert_dolog("jsid=$jsid&jsname=$add[jsname]");
		printerror("EditUserjsSuccess","ListUserjs.php");
	}
	else
	{
		printerror("DbError","history.go(-1)");
	}
}

//删除用户自定义js
function DelUserjs($jsid,$userid,$username){
	global $empire,$dbtbpre;
	$jsid=(int)$jsid;
	if(!$jsid)
	{
		printerror("NotChangeUserjsid","history.go(-1)");
	}
	//验证权限
	CheckLevel($userid,$username,$classid,"userjs");
	$r=$empire->fetch1("select jsname,jsfilename from {$dbtbpre}enewsuserjs where jsid=$jsid");
	$sql=$empire->query("delete from {$dbtbpre}enewsuserjs where jsid=$jsid");
	//删除文件
	DelFiletext("../".$r['jsfilename']);
	if($sql)
	{
		//操作日志
		insert_dolog("jsid=$jsid&jsname=$r[jsname]");
		printerror("DelUserjsSuccess","ListUserjs.php");
	}
	else
	{
		printerror("DbError","history.go(-1)");
	}
}

//增加自定义信息列表
function AddUserlist($add,$userid,$username){
	global $empire,$dbtbpre;
	$listtempid=(int)$add['listtempid'];
	$maxnum=(int)$add['maxnum'];
	$lencord=(int)$add['lencord'];
	if(!$add[listname]||!$listtempid||!$add[listsql]||!$add[totalsql]||!$add[filepath]||!$add[filetype]||!$add[lencord])
	{
		printerror("EmptyUserListname","history.go(-1)");
	}
	$query_first=substr($add['totalsql'],0,7);
	$query_firstlist=substr($add['listsql'],0,7);
	if(!($query_first=="select "||$query_first=="SELECT "||$query_firstlist=="select "||$query_firstlist=="SELECT "))
	{
		printerror("ListSqlError","history.go(-1)");
	}
	//验证权限
	CheckLevel($userid,$username,$classid,"userlist");
	if(empty($add['pagetitle']))
	{
		$add['pagetitle']=$add['listname'];
	}
	$add[totalsql]=ClearAddsData($add[totalsql]);
	$add[listsql]=ClearAddsData($add[listsql]);
	$sql=$empire->query("insert into {$dbtbpre}enewsuserlist(listname,pagetitle,filepath,filetype,totalsql,listsql,maxnum,lencord,listtempid) values('$add[listname]','$add[pagetitle]','$add[filepath]','$add[filetype]','".addslashes($add[totalsql])."','".addslashes($add[listsql])."',$maxnum,$lencord,$listtempid);");
	//刷新列表
	$add[listsql]=addslashes($add[listsql]);
	$add[totalsql]=addslashes($add[totalsql]);
	ReUserlist($add,"../");
	if($sql)
	{
		$listid=$empire->lastid();
		//操作日志
		insert_dolog("listid=$listid&listname=$add[listname]");
		printerror("AddUserlistSuccess","AddUserlist.php?enews=AddUserlist");
	}
	else
	{
		printerror("DbError","history.go(-1)");
	}
}

//修改自定义信息列表
function EditUserlist($add,$userid,$username){
	global $empire,$dbtbpre;
	$listid=(int)$add['listid'];
	$listtempid=(int)$add['listtempid'];
	$maxnum=(int)$add['maxnum'];
	$lencord=(int)$add['lencord'];
	if(!$listid||!$add[listname]||!$listtempid||!$add[listsql]||!$add[totalsql]||!$add[filepath]||!$add[filetype]||!$add[lencord])
	{
		printerror("EmptyUserListname","history.go(-1)");
	}
	$query_first=substr($add['totalsql'],0,7);
	$query_firstlist=substr($add['listsql'],0,7);
	if(!($query_first=="select "||$query_first=="SELECT "||$query_firstlist=="select "||$query_firstlist=="SELECT "))
	{
		printerror("ListSqlError","history.go(-1)");
	}
	//验证权限
	CheckLevel($userid,$username,$classid,"userlist");
	/*
	//删除旧文件
	if(!($add['oldfilepath']<>$add['filepath']||$add['oldfiletype']<>$add['filetype']))
	{
		DelFiletext($add['oldjsfilename']);
	}
	*/
	if(empty($add['pagetitle']))
	{
		$add['pagetitle']=$add['listname'];
	}
	$add[totalsql]=ClearAddsData($add[totalsql]);
	$add[listsql]=ClearAddsData($add[listsql]);
	$sql=$empire->query("update {$dbtbpre}enewsuserlist set listname='$add[listname]',pagetitle='$add[pagetitle]',filepath='$add[filepath]',filetype='$add[filetype]',totalsql='".addslashes($add['totalsql'])."',listsql='".addslashes($add['listsql'])."',maxnum=$maxnum,lencord=$lencord,listtempid=$listtempid where listid=$listid");
	//刷新列表
	$add[listsql]=addslashes($add[listsql]);
	$add[totalsql]=addslashes($add[totalsql]);
	ReUserlist($add,"../");
	if($sql)
	{
		//操作日志
	    insert_dolog("listid=$listid&listname=$add[listname]");
		printerror("EditUserlistSuccess","ListUserlist.php");
	}
	else
	{
		printerror("DbError","history.go(-1)");
	}
}

//删除自定义信息列表
function DelUserlist($listid,$userid,$username){
	global $empire,$dbtbpre;
	$listid=(int)$listid;
	if(!$listid)
	{
		printerror("NotChangeUserlistid","history.go(-1)");
	}
	//验证权限
	CheckLevel($userid,$username,$classid,"userlist");
	$r=$empire->fetch1("select listname from {$dbtbpre}enewsuserlist where listid=$listid");
	$sql=$empire->query("delete from {$dbtbpre}enewsuserlist where listid=$listid");
	if($sql)
	{
		//操作日志
		insert_dolog("listid=$listid&listname=$r[listname]");
		printerror("DelUserlistSuccess","ListUserlist.php");
	}
	else
	{
		printerror("DbError","history.go(-1)");
	}
}

//删除短信息
function DelMoreMsg($add,$userid,$username){
	global $empire,$dbtbpre;
	$starttime=RepPostVar($add['starttime']);
	$endtime=RepPostVar($add['endtime']);
	if(!$starttime||!$endtime)
	{
		printerror("EmptyDelMoreMsg","history.go(-1)");
	}
	//信箱类型
	$msgtype=(int)$add['msgtype'];
	if($msgtype==1)
	{
		$a=" and outbox=0";
	}
	elseif($msgtype==2)
	{
		$a=" and outbox=1";
	}
	elseif($msgtype==3)
	{
		$a=" and issys=1";
	}
	else
	{
		$a="";
	}
	//发件人
	$from_username=RepPostVar($add['from_username']);
	if($from_username)
	{
		if($add['fromlike']==1)
		{
			$a.=" and from_username like '%$from_username%'";
		}
		else
		{
			$a.=" and from_username='$from_username'";
		}
	}
	$to_username=RepPostVar($add['to_username']);
	if($to_username)
	{
		if($add['tolike']==1)
		{
			$a.=" and to_username like '%$to_username%'";
		}
		else
		{
			$a.=" and to_username='$to_username'";
		}
	}
	//关键字
	$keyboard=RepPostVar2($add['keyboard']);
	if(trim($keyboard))
	{
		//检索字段
		$keyfield=(int)$add['keyfield'];
		if($keyfield==1)
		{
			$likef="title like '%[!--key--]%'";
		}
		elseif($keyfield==2)
		{
			$likef="msgtext like '%[!--key--]%'";
		}
		else
		{
			$likef="title like '%[!--key--]%' or msgtext like '%[!--key--]%'";
		}
		$r=explode(",",$keyboard);
		$likekey="";
		$count=count($r);
		for($i=0;$i<$count;$i++)
		{
			if($i==0)
			{
				$or="";
			}
			else
			{
				$or=" or ";
			}
			$likekey.=$or.str_replace("[!--key--]",$r[$i],$likef);;
		}
		$a.=" and (".$likekey.")";
	}
	$sql=$empire->query("delete from {$dbtbpre}enewsqmsg where msgtime>'$starttime' and msgtime<'$endtime'".$a);
	if($sql)
	{
		//操作日志
		insert_dolog("starttime=$starttime&endtime=$endtime");
		printerror("DelMoreMsgSuccess","DelMoreMsg.php");
	}
	else
	{printerror("DbError","history.go(-1)");}
}

//返回会员组
function ReturnSendMemberGroup($r){
	global $user_groupid,$user_group;
	$count=count($r);
	if($count==0)
	{
		printerror("EmptySendMemberGroup","");
	}
	for($i=0;$i<$count;$i++)
	{
		if($i==0)
		{
			$or="";
		}
		else
		{
			$or=" or ";
		}
		$a.=$or.$user_group."='".$r[$i]."'";
		if($user_groupid==$r[$i])
		{
			$a.=" or ".$user_group."=0";
		}
		$checkbox.="<input type=hidden name='groupid[]' value='".$r[$i]."'>";
	}
	$re[0]="(".$a.")";
	$re[1]=$checkbox;
	return $re;
}

//批量发送站内信息
function DoSendMsg($add,$ecms=0,$userid,$username){
	global $empire,$dbtbpre,$user_userid,$user_username,$user_havemsg,$user_group,$user_tablename,$user_groupid,$user_email;
	$start=(int)$add['start'];
	$line=(int)$add['line'];
	$title=$add['title'];
	$msgtext=$add['msgtext'];
	if(empty($title)||empty($msgtext))
	{printerror("EmptySendMsg","history.go(-1)");}
	if($ecms==1)//发送邮件
	{
		$enews="SendEmail";
		$mess="SendEmailSuccess";
		$returnurl="SendEmail.php";
		$pr=$empire->fetch1("select sendmailtype,smtphost,fromemail,loginemail,emailusername,emailpassword,smtpport,emailname from {$dbtbpre}enewspublic limit 1");
		//发送初使化
		$mailer=FirstSendMail($pr,$title,$msgtext);
	}
	else//发送短信息
	{
		$enews="SendMsg";
		$mess="SendMsgSuccess";
		$returnurl="SendMsg.php";
	}
	//会员组
	$gr=ReturnSendMemberGroup($add['groupid']);
	$a=" and ".$gr[0];
	$b=0;
	$msgtime=date("Y-m-d H:i:s");
	$sql=$empire->query("select ".$user_userid.",".$user_username.",".$user_havemsg.",".$user_group.",".$user_email." from ".$user_tablename." where ".$user_userid.">$start".$a." order by ".$user_userid." limit ".$line);
	while($r=$empire->fetch($sql))
	{
		$b=1;
		$newstart=$r[$user_userid];
		if($ecms==1)
		{
			$mailer->AddAddress($r[$user_email]);
		}
		else
		{
			$r[$user_username]=doUtfAndGbk($r[$user_username],1);//编码转换
			$ititle=str_replace("[!--username--]",$r[$user_username],$title);
			$imsgtext=str_replace("[!--username--]",$r[$user_username],$msgtext);
			SendSiteMsg($ititle,$imsgtext,$msgtime,$r[$user_userid],$r[$user_username],$r[$user_havemsg]);
		}
	}
	if(empty($b))
	{
		//操作日志
		insert_dolog("title=$title");
		printerror($mess,$returnurl);
	}
	if($ecms==1)
	{
		if(!$mailer->Send())
		{
			echo $mailer->ErrorInfo;
		}
	}
	//输出下一组提交表单
	EchoSendMsgForm($enews,$returnurl,$newstart,$line,$gr[1],$add);
}

//输出一组提交表单
function EchoSendMsgForm($enews,$returnurl,$start,$line,$checkbox,$add){
	global $fun_r;
	?>
	<?=$fun_r['OneSendMsg']?>(<b><font color=red><?=$start?></font></b>)
	<form name="sendform" method="post" action="<?=$returnurl?>">
		<input type=hidden name="enews" value="<?=$enews?>">
		<input type=hidden name="start" value="<?=$start?>">
		<input type=hidden name="line" value="<?=$line?>">
		<?=$checkbox?>
		<input type=hidden name="title" value="<?=htmlspecialchars(ClearAddsData($add[title]))?>">
		<input type=hidden name="msgtext" value="<?=htmlspecialchars(ClearAddsData($add[msgtext]))?>">
	</form>
	<script>
	document.sendform.submit();
	</script>
	<?
	exit();
}

//发送站内短信息
function SendSiteMsg($title,$msgtext,$msgtime,$userid,$username,$havemsg){
	global $empire,$user_havemsg,$user_tablename,$user_userid,$dbtbpre;
	$isql=$empire->query("insert into {$dbtbpre}enewsqmsg(title,msgtext,haveread,msgtime,to_username,from_userid,from_username,outbox,issys) values('".addslashes($title)."','".addslashes($msgtext)."',0,'$msgtime','$username',0,'',0,1);");
	if(!$havemsg)
	{
		$usql=$empire->query("update {$user_tablename} set ".$user_havemsg."=1 where ".$user_userid."='".$userid."' limit 1");
	}
}

//批量设置栏目
function SetMoreClass($add,$userid,$username){
	global $empire,$dbtbpre;
	//验证权限
	CheckLevel($userid,$username,$classid,"class");
	$classid=$add['classid'];
	$count=count($classid);
	if($count==0)
	{
		printerror("NotChangeSetClass","");
	}
	for($i=0;$i<$count;$i++)
	{
		$or=" or ";
		if($i==0)
		{
			$or="";
		}
		$whereclass.=$or." classid='".$classid[$i]."'";
	}
	$seting="";
	//基本属性
	if($add['doclasstype'])
	{
		$seting.=",classtype='$add[classtype]'";
	}
	if($add['dosearchtempid'])
	{
		$seting.=",searchtempid='$add[searchtempid]'";
	}
	if($add['dolistorder'])
	{
		$seting.=",listorderf='$add[listorderf]',listorder='$add[listorder]'";
	}
	if($add['doreorder'])
	{
		$seting.=",reorderf='$add[reorderf]',reorder='$add[reorder]'";
	}
	if($add['dolistdt'])
	{
		$seting.=",listdt='$add[listdt]'";
	}
	if($add['doshowdt'])
	{
		$seting.=",showdt='$add[showdt]'";
	}
	if($add['doshowclass'])
	{
		$seting.=",showclass='$add[showclass]'";
	}
	//选项设置[大栏目]
	if($add['doclasstempid'])
	{
		$seting.=",classtempid='$add[classtempid]'";
	}
	if($add['doislist'])
	{
		$seting.=",islist='$add[islist]'";
	}
	if($add['doblisttempid'])
	{
		if(empty($add[blisttempid]))
		{
			printerror("LastMustChange","");
		}
		$seting.=",listtempid='$add[blisttempid]'";
	}
	if($add['dobdtlisttempid'])
	{
		$seting.=",dtlisttempid='$add[bdtlisttempid]'";
	}
	if($add['dobmaxnum'])
	{
		$seting.=",maxnum='$add[bmaxnum]'";
	}
	if($add['doblencord'])
	{
		$seting.=",lencord='$add[blencord]'";
	}
	//选项设置[终极栏目]
	if(!($add['doclasstempid']||$add['doislist']||$add['doblisttempid']||$add['dobmaxnum']||$add['doblencord']||$add['dobdtlisttempid']))
	{
		if($add['dolisttempid'])
		{
			if(empty($add[listtempid]))
			{
				printerror("LastMustChange","");
			}
			$seting.=",listtempid='$add[listtempid]'";
		}
		if($add['dodtlisttempid'])
		{
			$seting.=",dtlisttempid='$add[dtlisttempid]'";
		}
		if($add['donewstempid'])
		{
			if(empty($add[newstempid]))
			{
				printerror("LastMustChange","");
			}
			$seting.=",newstempid='$add[newstempid]'";
			if($add['tobetempinfo'])
			{
				$donewstemp=1;
			}
		}
		if($add['domaxnum'])
		{
			$seting.=",maxnum='$add[maxnum]'";
		}
		if($add['dolencord'])
		{
			$seting.=",lencord='$add[lencord]'";
		}
		if($add['dolink_num'])
		{
			$seting.=",link_num='$add[link_num]'";
		}
		if($add['donewspath'])
		{
			$seting.=",newspath='$add[newspath]'";
		}
		if($add['dofilename_qz'])
		{
			$seting.=",filename_qz='$add[filename_qz]'";
		}
		if($add['dofilename'])
		{
			$seting.=",filename='$add[filename]'";
		}
		if($add['dofiletype'])
		{
			$seting.=",filetype='$add[filetype]'";
		}
		if($add['doopenpl'])
		{
			$seting.=",openpl='$add[openpl]'";
		}
		if($add['doopenadd'])
		{
			$seting.=",openadd='$add[openadd]'";
		}
		if($add['dochecked'])
		{
			$seting.=",checked='$add[checked]'";
		}
		if($add['dodoctime'])
		{
			$seting.=",doctime='$add[doctime]'";
		}
	}
	//特殊模型设置
	if($add['dodown_num'])
	{
		$seting.=",down_num='$add[down_num]'";
	}
	if($add['doonline_num'])
	{
		$seting.=",online_num='$add[online_num]'";
	}
	//JS调用设置
	if($add['dojstempid'])
	{
		$seting.=",jstempid='$add[jstempid]'";
	}
	if($add['donewjs'])
	{
		$seting.=",newline='$add[newline]',newstrlen='$add[newstrlen]',newshowdate='$add[newshowdate]'";
	}
	if($add['dohotjs'])
	{
		$seting.=",hotline='$add[hotline]',hotstrlen='$add[hotstrlen]',hotshowdate='$add[hotshowdate]'";
	}
	if($add['dogoodjs'])
	{
		$seting.=",goodline='$add[goodline]',goodstrlen='$add[goodstrlen]',goodshowdate='$add[goodshowdate]'";
	}
	if($add['dohotpljs'])
	{
		$seting.=",hotplline='$add[hotplline]',hotplstrlen='$add[hotplstrlen]',hotplshowdate='$add[hotplshowdate]'";
	}
	if($add['dofirstjs'])
	{
		$seting.=",firstline='$add[firstline]',firststrlen='$add[firststrlen]',firstshowdate='$add[firstshowdate]'";
	}
	if(empty($seting))
	{
		printerror("NotChangeSetClassInfo","");
	}
	$seting=substr($seting,1);
	$sql=$empire->query("update {$dbtbpre}enewsclass set ".$seting." where ".$whereclass);
	//内容模板应用于子生成的信息
	if($donewstemp==1)
	{
		$csql=$empire->query("select classid,tbname from {$dbtbpre}enewsclass where (".$whereclass.") and islast=1");
		while($r=$empire->fetch($csql))
		{
			$upsql=$empire->query("update {$dbtbpre}ecms_".$r[tbname]." set newstempid='$add[newstempid]' where classid='$r[classid]'");
		}
	}
	if($sql)
	{
		GetClass();
		//操作日志
		insert_dolog("");
		printerror("SetMoreClassSuccess","SetMoreClass.php");
	}
	else
	{printerror("DbError","");}
}

//组合专题
function TogZt($add,$userid,$username){
	global $empire,$class_r,$dbtbpre;
	$ztid=(int)$add['ztid'];
	if(empty($ztid))
	{
		printerror("ErrorUrl","history.go(-1)");
    }
	$r=$empire->fetch1("select ztid,ztname,tbname from {$dbtbpre}enewszt where ztid=$ztid");
	if(empty($r['ztid'])||empty($r['tbname']))
	{
		printerror("ErrorUrl","history.go(-1)");
	}
	$wheresql="";
	$formvar="";
	//关键字
	$keyboard=RepPostVar2($add['keyboard']);
	if($keyboard)
	{
		$formvar.=ReturnFormHidden('keyboard',$add['keyboard']);
		$searchfsql='';
		if($add['stitle'])//标题
		{
			$searchfsql.="title like '%$keyboard%'";
			$formvar.=ReturnFormHidden('stitle',$add['stitle']);
		}
		if($add['susername'])//增加者
		{
			if($searchfsql)
			{
				$or=" or ";
			}
			$searchfsql.=$or."username like '%$keyboard%'";
			$formvar.=ReturnFormHidden('susername',$add['susername']);
		}
		if($add['snewstext'])//内容
		{
			$or="";
			if($searchfsql)
			{
				$or=" or ";
			}
			$searchfsql.=$or."newstext like '%$keyboard%'";
			$formvar.=ReturnFormHidden('snewstext',$add['snewstext']);
		}
		if($searchfsql)
		{
			$wheresql=" and (".$searchfsql.")";
		}
	}
	//是否推荐
	if($add['isgood'])
	{
		$wheresql.=" and isgood=1";
		$formvar.=ReturnFormHidden('isgood',$add['isgood']);
	}
	//头条
	if($add['firsttitle'])
	{
		$wheresql.=" and firsttitle=1";
		$formvar.=ReturnFormHidden('firsttitle',$add['firsttitle']);
	}
	//有标题图片
	if($add['titlepic'])
	{
		$wheresql.=" and titlepic<>''";
		$formvar.=ReturnFormHidden('titlepic',$add['titlepic']);
	}
	//审核
	if($add['checked'])
	{
		$wheresql.=" and checked=1";
		$formvar.=ReturnFormHidden('checked',$add['checked']);
	}
	//按栏目刷新
	$classid=(int)$add['classid'];
    if($classid)
	{
		$formvar.=ReturnFormHidden('classid',$add['classid']);
		//大栏目
		if(empty($class_r[$classid][islast]))
		{
			$where=ReturnClass($class_r[$classid][sonclass]);
		}
		//终极栏目
		else
		{
			$where="classid='$classid'";
		}
		$wheresql.=" and (".$where.")";
    }
	$startid=(int)$add[startid];
	$endid=(int)$add[endid];
	$startday=RepPostVar($add[startday]);
	$endday=RepPostVar($add[endday]);
	$formvar.=ReturnFormHidden('retype',$add['retype']);
	//按ID
    if($add['retype'])
	{
		if($endid)
		{
			$wheresql.=" and id>=$startid and id<=$endid";
			$formvar.=ReturnFormHidden('startid',$add[startid]).ReturnFormHidden('endid',$add[endid]);
	    }
    }
    else
	{
		if($startday&&$endday)
		{
			$wheresql.=" and truetime>=".to_time($startday." 00:00:00")." and truetime<=".to_time($endday." 23:59:59");
			$formvar.=ReturnFormHidden('startday',$add[startday]).ReturnFormHidden('endday',$add[endday]);
	    }
    }
	//附件sql条件
	$query=$add['query'];
	if($query)
	{
		$query=ClearAddsData($query);//去除adds
		$wheresql.=" and (".$query.")";
		$formvar.=ReturnFormHidden('query',$add['query']);
	}
	$wheresql=" where ztid not like '%|".$ztid."|%'".$wheresql;
	$owheresql=$wheresql." and ztid=''";
	if($add['doecmszt'])
	{
		if($add['inid'])
		{
			$add['inid']=RepPostVar($add['inid']);
			$wheresql.=" and id not in (".$add['inid'].")";
			$owheresql.=" and id not in (".$add['inid'].")";
		}
		$repztid="|".$ztid."|";
		$conztid=$ztid."|";
		//将空格转换成|
		$usql=$empire->query("update {$dbtbpre}ecms_".$r['tbname']." set ztid='|'".$owheresql);
		//组成新专题
		$sql=$empire->query("update {$dbtbpre}ecms_".$r['tbname']." set ztid=CONCAT(REPLACE(ztid,'".$repztid."','|'),'".$conztid."')".$wheresql);
		if($usql&&$sql)
		{
			//操作日志
	        insert_dolog("ztid=$ztid&ztname=$r[ztname]");
			printerror("TogZtSuccess","TogZt.php?ztid=$ztid");
		}
		else
		{
			printerror("DbError","history.go(-1)");
		}
	}
	$re[0]=$wheresql;
	$re[1]=$formvar.ReturnFormHidden('ztid',$ztid).ReturnFormHidden('pline',$add[pline]).ReturnFormHidden('doecmszt',$add[doecmszt]).ReturnFormHidden('enews',$add[enews]).ReturnFormHidden('inid',$add[inid]);
	$re[2]=$r['tbname'];
	$re[3]=$r['ztname'];
	return $re;
}

//附加隐藏表单项
function ReturnFormHidden($vname,$value){
	$value=htmlspecialchars(ClearAddsData($value));
	return "<input type=hidden name=\"".$vname."\" value=\"".$value."\">";
}

//修改模板组
function EditTempGroup($add,$userid,$username){
	global $empire,$dbtbpre;
	//验证权限
	CheckLevel($userid,$username,$classid,"tempgroup");
	$gid=$add['gid'];
	$gname=$add['gname'];
	$count=count($gid);
	for($i=0;$i<$count;$i++)
	{
		$usql=$empire->query("update {$dbtbpre}enewstempgroup set gname='".$gname[$i]."' where gid='".$gid[$i]."'");
	}
	//操作日志
	insert_dolog("");
	printerror("EditTempGroupSuccess","TempGroup.php");
}

//默认模板组
function DefTtempGroup($add,$userid,$username){
	global $empire,$dbtbpre;
	//验证权限
	CheckLevel($userid,$username,$classid,"tempgroup");
	$gid=(int)$add['changegid'];
	if(!$gid)
	{
		printerror("EmptyTempGroup","");
	}
	$r=$empire->fetch1("select gid,gname from {$dbtbpre}enewstempgroup where gid=$gid");
	if(!$r['gid'])
	{
		printerror("EmptyTempGroup","");
	}
	$usql=$empire->query("update {$dbtbpre}enewstempgroup set isdefault=0");
	$sql=$empire->query("update {$dbtbpre}enewstempgroup set isdefault=1 where gid=$gid");
	$upsql=$empire->query("update {$dbtbpre}enewspublic set deftempid=$gid limit 1");
	if($usql&&$sql&&$upsql)
	{
		GetConfig();
		//操作日志
		insert_dolog("gid=$gid&gname=$r[gname]");
		printerror("DefTempGroupSuccess","TempGroup.php");
	}
	else
	{
		printerror("DbError","");
	}
}

//返回模板表
function ReturnTemptbList(){
	$templist="enewsbqtemp,enewsjstemp,enewslisttemp,enewsnewstemp,enewspubtemp,enewssearchtemp,enewstempvar,enewsvotetemp,enewsclasstemp";
	return $templist;
}

//删除模板数据表
function DelTempTb($gid){
	global $empire,$dbtbpre;
	if($gid==1)
	{
		return "";
	}
	$templist=ReturnTemptbList();
	$r=explode(",",$templist);
	$count=count($r);
	$droptb="";
	for($i=0;$i<$count;$i++)
	{
		$dh=",";
		if($i==0)
		{
			$dh="";
		}
		$droptb.=$dh.$dbtbpre.$r[$i]."_".$gid;
	}
	$sql=$empire->query("DROP TABLE IF EXISTS ".$droptb.";");
	return $sql;
}

//清空模板数据表
function ClearTempTb($gid,$en){
	global $empire,$dbtbpre;
	$templist=ReturnTemptbList();
	$r=explode(",",$templist);
	$count=count($r);
	for($i=0;$i<$count;$i++)
	{
		$tb=$dbtbpre.$r[$i].$en;
		$empire->query("TRUNCATE `".$tb."`;");
	}
}

//新建模板数据表
function CreateTempTb($gid,$en){
	global $empire,$dbtbpre;
	if($gid==1)
	{
		return "";
	}
	$templist=ReturnTemptbList();
	$r=explode(",",$templist);
	$count=count($r);
	for($i=0;$i<$count;$i++)
	{
		$otb=$dbtbpre.$r[$i];
		$tb=$dbtbpre.$r[$i].$en;
		CopyEcmsTb($otb,$tb);
	}
}

//删除模板组
function DelTempGroup($add,$userid,$username){
	global $empire,$dbtbpre;
	//验证权限
	CheckLevel($userid,$username,$classid,"tempgroup");
	$gid=(int)$add['changegid'];
	if(!$gid)
	{
		printerror("EmptyDelTempGroup","");
	}
	if($gid==1)
	{
		printerror("NotDelDefTempGroup","");
	}
	$r=$empire->fetch1("select gid,gname,isdefault from {$dbtbpre}enewstempgroup where gid=$gid");
	if(!$r['gid'])
	{
		printerror("EmptyDelTempGroup","");
	}
	$sql=$empire->query("delete from {$dbtbpre}enewstempgroup where gid=$gid");
	if($r['isdefault'])
	{
		$upsql=$empire->query("update {$dbtbpre}enewspublic set deftempid=0 limit 1");
		GetConfig();
	}
	DelTempTb($gid);
	if($sql)
	{
		//操作日志
		insert_dolog("gid=$gid&gname=$r[gname]");
		printerror("DelTempGroupSuccess","TempGroup.php");
	}
	else
	{
		printerror("DbError","");
	}
}

//导出模板组
function LoadTempGroup($add,$userid,$username){
	global $empire,$dbtbpre;
	//验证权限
	CheckLevel($userid,$username,$classid,"tempgroup");
	$gid=(int)$add['changegid'];
	if(!$gid)
	{
		printerror("EmptyLoadTempGroup","");
	}
	$r=$empire->fetch1("select gid,gname from {$dbtbpre}enewstempgroup where gid=$gid");
	if(!$r['gid'])
	{
		printerror("EmptyLoadTempGroup","");
	}
	$pageexp="<!---ecms.temp--->";
	$record="<!---ecms.record--->";
	$field="<!---ecms.field--->";
	if($gid==1)
	{
		$en="";
	}
	else
	{
		$en="_".$gid;
	}
	$bqtemp=LoadTGBqtemp($gid,$en,$pageexp,$record,$field);//标签模板
	$jstemp=LoadTGJstemp($gid,$en,$pageexp,$record,$field);//JS模板
	$listtemp=LoadTGListtemp($gid,$en,$pageexp,$record,$field);//列表模板
	$newstemp=LoadTGNewstemp($gid,$en,$pageexp,$record,$field);//内容模板
	$pubtemp=LoadTGPubtemp($gid,$en,$pageexp,$record,$field);//公共模板
	$searchtemp=LoadTGSearchtemp($gid,$en,$pageexp,$record,$field);//搜索模板
	$tempvar=LoadTGTempvar($gid,$en,$pageexp,$record,$field);//模板变量
	$votetemp=LoadTGVotetemp($gid,$en,$pageexp,$record,$field);//投票模板
	$classtemp=LoadTGClasstemp($gid,$en,$pageexp,$record,$field);//栏目模板
	$loadtemptext=$r['gname'].$pageexp.$bqtemp.$pageexp.$jstemp.$pageexp.$listtemp.$pageexp.$newstemp.$pageexp.$pubtemp.$pageexp.$searchtemp.$pageexp.$tempvar.$pageexp.$votetemp.$pageexp.$classtemp;
	$loadtemptext=stripSlashes($loadtemptext);
	$file="e".time().".temp";
	$filepath="data/".$file;
	WriteFiletext_n($filepath,$loadtemptext);
	DownLoadFile($file,$filepath,1);
	//操作日志
	insert_dolog("gid=$gid&gname=$r[gname]");
	exit();
}

//导入模板组
function LoadInTempGroup($add,$file,$file_name,$file_type,$file_size,$userid,$username){
	global $empire,$dbtbpre;
	//验证权限
	CheckLevel($userid,$username,$classid,"tempgroup");
	if(!$file_name||!$file_size)
	{
		printerror("EmptyLoadInTempGroup","");
	}
	$gid=(int)$add['gid'];
	//扩展名
	$filetype=GetFiletype($file_name);
	if($filetype!=".temp")
	{
		printerror("LoadInTempGroupMusttemp","");
	}
	//上传文件
	$path="data/uploadtg".time().".temp";
	$cp=@move_uploaded_file($file,$path);
	DoChmodFile($path);
	$data=ReadFiletext($path);
	DelFiletext($path);
	if(empty($data))
	{
		printerror("EmptyLoadInTempGroup","");
	}
	//入库
	$pageexp="<!---ecms.temp--->";
	$record="<!---ecms.record--->";
	$field="<!---ecms.field--->";
	$pr=explode($pageexp,$data);
	if(empty($gid))//新建模板组
	{
		$sql=$empire->query("insert into {$dbtbpre}enewstempgroup(gname,isdefault) values('".addslashes($pr[0])."',0);");
		$gid=$empire->lastid();
		$gname=$pr[0];
		$en="_".$gid;
		CreateTempTb($gid,$en);//复制表
	}
	else//覆盖模板组
	{
		$r=$empire->fetch1("select gid,gname from {$dbtbpre}enewstempgroup where gid=$gid");
		if(!$r['gid'])
		{
			printerror("LoadInTempGroupMusttemp","");
		}
		if($gid==1)
		{
			$en="";
		}
		else
		{
			$en="_".$gid;
		}
		$gname=$r['gname'];
		ClearTempTb($gid,$en);//清空表
	}
	LoadInTGBqtemp($gid,$en,$record,$field,$pr[1]);//标签模板
	LoadInTGJstemp($gid,$en,$record,$field,$pr[2]);//JS模板
	LoadInTGListtemp($gid,$en,$record,$field,$pr[3]);//列表模板
	LoadInTGNewstemp($gid,$en,$record,$field,$pr[4]);//内容模板
	LoadInTGPubtemp($gid,$en,$record,$field,$pr[5]);//公共模板
	LoadInTGSearchtemp($gid,$en,$record,$field,$pr[6]);//搜索模板
	LoadInTGTempvar($gid,$en,$record,$field,$pr[7]);//模板变量
	LoadInTGVotetemp($gid,$en,$record,$field,$pr[8]);//投票模板
	LoadInTGClasstemp($gid,$en,$record,$field,$pr[9]);//栏目模板
	//操作日志
	insert_dolog("gid=$gid&gname=$gname");
	printerror("LoadInTempGroupSuccess","TempGroup.php");
}

//替换模板组存放格式
function ReplaceLoadTGTemp($pageexp,$record,$field,$text){
	$text=str_replace($pageexp,"",$text);
	$text=str_replace($record,"",$text);
	$text=str_replace($field,"",$text);
	return $text;
}

//标签模板
function LoadTGBqtemp($gid,$en,$pageexp,$record,$field){
	global $empire,$dbtbpre;
	$tb=$dbtbpre."enewsbqtemp".$en;
	$sql=$empire->query("select * from ".$tb." order by tempid");
	$classid=0;
	while($r=$empire->fetch($sql))
	{
		$r['temptext']=ReplaceLoadTGTemp($pageexp,$record,$field,$r['temptext']);
		$r['listvar']=ReplaceLoadTGTemp($pageexp,$record,$field,$r['listvar']);
		$text.=$r['tempid'].$field.$r['tempname'].$field.$r['modid'].$field.$r['temptext'].$field.$r['showdate'].$field.$r['listvar'].$field.$r['subnews'].$field.$r['rownum'].$field.$classid.$record;
	}
	return $text;
}

function LoadInTGBqtemp($gid,$en,$record,$field,$text){
	global $empire,$dbtbpre;
	if(empty($text))
	{
		return "";
	}
	$tb=$dbtbpre."enewsbqtemp".$en;
	$rr=explode($record,$text);
	$count=count($rr);
	for($i=0;$i<$count-1;$i++)
	{
		$r=explode($field,$rr[$i]);
		$sql=$empire->query("insert into ".$tb."(tempid,tempname,modid,temptext,showdate,listvar,subnews,rownum,classid) values('$r[0]','".addslashes($r[1])."','$r[2]','".addslashes($r[3])."','".addslashes($r[4])."','".addslashes($r[5])."','$r[6]','$r[7]','$r[8]');");
	}
}

//JS模板
function LoadTGJstemp($gid,$en,$pageexp,$record,$field){
	global $empire,$dbtbpre;
	$tb=$dbtbpre."enewsjstemp".$en;
	$sql=$empire->query("select * from ".$tb." order by tempid");
	$classid=0;
	while($r=$empire->fetch($sql))
	{
		$r['temptext']=ReplaceLoadTGTemp($pageexp,$record,$field,$r['temptext']);
		$text.=$r['tempid'].$field.$r['tempname'].$field.$r['temptext'].$field.$classid.$field.$r['isdefault'].$field.$r['showdate'].$record;
	}
	return $text;
}

function LoadInTGJstemp($gid,$en,$record,$field,$text){
	global $empire,$dbtbpre;
	if(empty($text))
	{
		return "";
	}
	$tb=$dbtbpre."enewsjstemp".$en;
	$rr=explode($record,$text);
	$count=count($rr);
	for($i=0;$i<$count-1;$i++)
	{
		$r=explode($field,$rr[$i]);
		$sql=$empire->query("insert into ".$tb."(tempid,tempname,temptext,classid,isdefault,showdate) values('$r[0]','".addslashes($r[1])."','".addslashes($r[2])."','$r[3]','$r[4]','".addslashes($r[5])."');");
	}
}

//列表模板
function LoadTGListtemp($gid,$en,$pageexp,$record,$field){
	global $empire,$dbtbpre;
	$tb=$dbtbpre."enewslisttemp".$en;
	$sql=$empire->query("select * from ".$tb." order by tempid");
	$classid=0;
	while($r=$empire->fetch($sql))
	{
		$r['temptext']=ReplaceLoadTGTemp($pageexp,$record,$field,$r['temptext']);
		$r['listvar']=ReplaceLoadTGTemp($pageexp,$record,$field,$r['listvar']);
		$text.=$r['tempid'].$field.$r['tempname'].$field.$r['temptext'].$field.$r['subnews'].$field.$r['isdefault'].$field.$r['listvar'].$field.$r['rownum'].$field.$r['modid'].$field.$r['showdate'].$field.$r['subtitle'].$field.$classid.$record;
	}
	return $text;
}

function LoadInTGListtemp($gid,$en,$record,$field,$text){
	global $empire,$dbtbpre;
	if(empty($text))
	{
		return "";
	}
	$tb=$dbtbpre."enewslisttemp".$en;
	$rr=explode($record,$text);
	$count=count($rr);
	for($i=0;$i<$count-1;$i++)
	{
		$r=explode($field,$rr[$i]);
		$sql=$empire->query("insert into ".$tb."(tempid,tempname,temptext,subnews,isdefault,listvar,rownum,modid,showdate,subtitle,classid) values('$r[0]','".addslashes($r[1])."','".addslashes($r[2])."','$r[3]','$r[4]','".addslashes($r[5])."','$r[6]','$r[7]','".addslashes($r[8])."','$r[9]','$r[10]');");
	}
}

//内容模板
function LoadTGNewstemp($gid,$en,$pageexp,$record,$field){
	global $empire,$dbtbpre;
	$tb=$dbtbpre."enewsnewstemp".$en;
	$sql=$empire->query("select * from ".$tb." order by tempid");
	$classid=0;
	while($r=$empire->fetch($sql))
	{
		$r['temptext']=ReplaceLoadTGTemp($pageexp,$record,$field,$r['temptext']);
		$text.=$r['tempid'].$field.$r['tempname'].$field.$r['isdefault'].$field.$r['temptext'].$field.$r['showdate'].$field.$r['modid'].$field.$classid.$record;
	}
	return $text;
}

function LoadInTGNewstemp($gid,$en,$record,$field,$text){
	global $empire,$dbtbpre;
	if(empty($text))
	{
		return "";
	}
	$tb=$dbtbpre."enewsnewstemp".$en;
	$rr=explode($record,$text);
	$count=count($rr);
	for($i=0;$i<$count-1;$i++)
	{
		$r=explode($field,$rr[$i]);
		$sql=$empire->query("insert into ".$tb."(tempid,tempname,isdefault,temptext,showdate,modid,classid) values('$r[0]','".addslashes($r[1])."','$r[2]','".addslashes($r[3])."','".addslashes($r[4])."','$r[5]','$r[6]');");
	}
}

//公共模板
function LoadTGPubtemp($gid,$en,$pageexp,$record,$field){
	global $empire,$dbtbpre;
	$tb=$dbtbpre."enewspubtemp".$en;
	$r=$empire->fetch1("select * from ".$tb." limit 1");
	$r['indextemp']=ReplaceLoadTGTemp($pageexp,$record,$field,$r['indextemp']);
	$r['pllisttemp']=ReplaceLoadTGTemp($pageexp,$record,$field,$r['pllisttemp']);
	$r['cptemp']=ReplaceLoadTGTemp($pageexp,$record,$field,$r['cptemp']);
	$r['searchtemp']=ReplaceLoadTGTemp($pageexp,$record,$field,$r['searchtemp']);
	$r['searchjstemp']=ReplaceLoadTGTemp($pageexp,$record,$field,$r['searchjstemp']);
	$r['searchjstemp1']=ReplaceLoadTGTemp($pageexp,$record,$field,$r['searchjstemp1']);
	$r['otherlinktemp']=ReplaceLoadTGTemp($pageexp,$record,$field,$r['otherlinktemp']);
	$r['printtemp']=ReplaceLoadTGTemp($pageexp,$record,$field,$r['printtemp']);
	$r['downsofttemp']=ReplaceLoadTGTemp($pageexp,$record,$field,$r['downsofttemp']);
	$r['onlinemovietemp']=ReplaceLoadTGTemp($pageexp,$record,$field,$r['onlinemovietemp']);
	$r['listpagetemp']=ReplaceLoadTGTemp($pageexp,$record,$field,$r['listpagetemp']);
	$r['gbooktemp']=ReplaceLoadTGTemp($pageexp,$record,$field,$r['gbooktemp']);
	$r['loginiframe']=ReplaceLoadTGTemp($pageexp,$record,$field,$r['loginiframe']);
	$r['loginjstemp']=ReplaceLoadTGTemp($pageexp,$record,$field,$r['loginjstemp']);
	$text.=$r['id'].$field.$r['indextemp'].$field.$r['pllisttemp'].$field.$r['cptemp'].$field.$r['searchtemp'].$field.$r['searchjstemp'].$field.$r['searchjstemp1'].$field.$r['otherlinktemp'].$field.$r['printtemp'].$field.$r['downsofttemp'].$field.$r['onlinemovietemp'].$field.$r['listpagetemp'].$field.$r['gbooktemp'].$field.$r['loginiframe'].$field.$r['otherlinktempsub'].$field.$r['otherlinktempdate'].$field.$r['loginjstemp'].$record;
	return $text;
}

function LoadInTGPubtemp($gid,$en,$record,$field,$text){
	global $empire,$dbtbpre;
	if(empty($text))
	{
		return "";
	}
	$tb=$dbtbpre."enewspubtemp".$en;
	$rr=explode($record,$text);
	$r=explode($field,$rr[0]);
	//相关链接设置
	if(empty($r[14]))
	{
		$r[14]=30;
	}
	if(empty($r[15]))
	{
		$r[15]='Y-m-d H:i:s';
	}
	$sql=$empire->query("insert into ".$tb."(id,indextemp,pllisttemp,cptemp,searchtemp,searchjstemp,searchjstemp1,otherlinktemp,printtemp,downsofttemp,onlinemovietemp,listpagetemp,gbooktemp,loginiframe,otherlinktempsub,otherlinktempdate,loginjstemp) values('$r[0]','".addslashes($r[1])."','".addslashes($r[2])."','".addslashes($r[3])."','".addslashes($r[4])."','".addslashes($r[5])."','".addslashes($r[6])."','".addslashes($r[7])."','".addslashes($r[8])."','".addslashes($r[9])."','".addslashes($r[10])."','".addslashes($r[11])."','".addslashes($r[12])."','".addslashes($r[13])."','$r[14]','$r[15]','".addslashes($r[16])."');");
}

//搜索模板
function LoadTGSearchtemp($gid,$en,$pageexp,$record,$field){
	global $empire,$dbtbpre;
	$tb=$dbtbpre."enewssearchtemp".$en;
	$sql=$empire->query("select * from ".$tb." order by tempid");
	$classid=0;
	while($r=$empire->fetch($sql))
	{
		$r['temptext']=ReplaceLoadTGTemp($pageexp,$record,$field,$r['temptext']);
		$r['listvar']=ReplaceLoadTGTemp($pageexp,$record,$field,$r['listvar']);
		$text.=$r['tempid'].$field.$r['tempname'].$field.$r['temptext'].$field.$r['subnews'].$field.$r['isdefault'].$field.$r['listvar'].$field.$r['rownum'].$field.$r['modid'].$field.$r['showdate'].$field.$r['subtitle'].$field.$classid.$record;
	}
	return $text;
}

function LoadInTGSearchtemp($gid,$en,$record,$field,$text){
	global $empire,$dbtbpre;
	if(empty($text))
	{
		return "";
	}
	$tb=$dbtbpre."enewssearchtemp".$en;
	$rr=explode($record,$text);
	$count=count($rr);
	for($i=0;$i<$count-1;$i++)
	{
		$r=explode($field,$rr[$i]);
		$sql=$empire->query("insert into ".$tb."(tempid,tempname,temptext,subnews,isdefault,listvar,rownum,modid,showdate,subtitle,classid) values('$r[0]','".addslashes($r[1])."','".addslashes($r[2])."','$r[3]','$r[4]','".addslashes($r[5])."','$r[6]','$r[7]','".addslashes($r[8])."','$r[9]','$r[10]');");
	}
}

//模板变量
function LoadTGTempvar($gid,$en,$pageexp,$record,$field){
	global $empire,$dbtbpre;
	$tb=$dbtbpre."enewstempvar".$en;
	$sql=$empire->query("select * from ".$tb." order by varid");
	$classid=0;
	while($r=$empire->fetch($sql))
	{
		$r['varvalue']=ReplaceLoadTGTemp($pageexp,$record,$field,$r['varvalue']);
		$text.=$r['varid'].$field.$r['myvar'].$field.$r['varname'].$field.$r['varvalue'].$field.$classid.$field.$r['isclose'].$field.$r['myorder'].$record;
	}
	return $text;
}

function LoadInTGTempvar($gid,$en,$record,$field,$text){
	global $empire,$dbtbpre;
	if(empty($text))
	{
		return "";
	}
	$tb=$dbtbpre."enewstempvar".$en;
	$rr=explode($record,$text);
	$count=count($rr);
	for($i=0;$i<$count-1;$i++)
	{
		$r=explode($field,$rr[$i]);
		$sql=$empire->query("insert into ".$tb."(varid,myvar,varname,varvalue,classid,isclose,myorder) values('$r[0]','".addslashes($r[1])."','".addslashes($r[2])."','".addslashes($r[3])."','$r[4]','$r[5]','$r[6]');");
	}
}

//投票模板
function LoadTGVotetemp($gid,$en,$pageexp,$record,$field){
	global $empire,$dbtbpre;
	$tb=$dbtbpre."enewsvotetemp".$en;
	$sql=$empire->query("select * from ".$tb." order by tempid");
	$classid=0;
	while($r=$empire->fetch($sql))
	{
		$r['temptext']=ReplaceLoadTGTemp($pageexp,$record,$field,$r['temptext']);
		$text.=$r['tempid'].$field.$r['tempname'].$field.$r['temptext'].$record;
	}
	return $text;
}

function LoadInTGVotetemp($gid,$en,$record,$field,$text){
	global $empire,$dbtbpre;
	if(empty($text))
	{
		return "";
	}
	$tb=$dbtbpre."enewsvotetemp".$en;
	$rr=explode($record,$text);
	$count=count($rr);
	for($i=0;$i<$count-1;$i++)
	{
		$r=explode($field,$rr[$i]);
		$sql=$empire->query("insert into ".$tb."(tempid,tempname,temptext) values('$r[0]','".addslashes($r[1])."','".addslashes($r[2])."');");
	}
}

//栏目封面模板
function LoadTGClasstemp($gid,$en,$pageexp,$record,$field){
	global $empire,$dbtbpre;
	$tb=$dbtbpre."enewsclasstemp".$en;
	$sql=$empire->query("select * from ".$tb." order by tempid");
	$classid=0;
	while($r=$empire->fetch($sql))
	{
		$r['temptext']=ReplaceLoadTGTemp($pageexp,$record,$field,$r['temptext']);
		$text.=$r['tempid'].$field.$r['tempname'].$field.$r['temptext'].$field.$classid.$record;
	}
	return $text;
}

function LoadInTGClasstemp($gid,$en,$record,$field,$text){
	global $empire,$dbtbpre;
	if(empty($text))
	{
		return "";
	}
	$tb=$dbtbpre."enewsclasstemp".$en;
	$rr=explode($record,$text);
	$count=count($rr);
	for($i=0;$i<$count-1;$i++)
	{
		$r=explode($field,$rr[$i]);
		$sql=$empire->query("insert into ".$tb."(tempid,tempname,temptext,classid) values('$r[0]','".addslashes($r[1])."','".addslashes($r[2])."','$r[3]');");
	}
}

//导出系统模型
function LoadOutMod($add,$userid,$username){
	global $empire,$dbtbpre;
	$tid=(int)$add['tid'];
	$tbname=RepPostVar($add['tbname']);
	$mid=(int)$add['mid'];
	if(!$tid||!$tbname||!$mid)
	{
		printerror("EmptyLoadMod","");
	}
	$mr=$empire->fetch1("select * from {$dbtbpre}enewsmod where mid=$mid and tid=$tid");
	if(!$mr['mid'])
	{
		printerror("EmptyLoadMod","");
	}
	$tr=$empire->fetch1("select tbname,tname,tsay from {$dbtbpre}enewstable where tid=$tid");
	if(!$tr['tbname'])
	{
		printerror("EmptyLoadMod","");
	}
	//数据表结构
	$loadmod="<?php
".LoadModReturnstru($dbtbpre."ecms_".$mr['tbname'],$mr['tbname'],0)."\r\n";
	$loadmod.=LoadModReturnstru($dbtbpre."ecms_".$mr['tbname']."_doc",$mr['tbname'],1)."\r\n";
	$loadmod.=LoadModReturnstru($dbtbpre."ecms_infoclass_".$mr['tbname'],$mr['tbname'],2)."\r\n";
	$loadmod.=LoadModReturnstru($dbtbpre."ecms_infotmp_".$mr['tbname'],$mr['tbname'],3)."\r\n";
	//数据表
	$loadmod.="\$empire->query(\"insert into \".\$dbtbpre.\"enewstable(tbname,tname,tsay,isdefault) values('\$tbname','".$tr[tname]."','".LMEscape_str($tr[tsay])."',0);\");
\$tid=\$empire->lastid();
";
	//字段
	$fsql=$empire->query("select * from {$dbtbpre}enewsf where tid=$tid order by fid");
	while($fr=$empire->fetch($fsql))
	{
		$loadmod.="\$empire->query(\"insert into \".\$dbtbpre.\"enewsf(f,fname,fform,fhtml,fzs,isadd,isshow,iscj,cjhtml,myorder,ftype,flen,dotemp,tid,tbname,savetxt,fvalue,iskey,tobr,dohtml,qfhtml,isonly,linkfieldval,samedata,fformsize) values('$fr[f]','$fr[fname]','$fr[fform]','".LMEscape_str($fr['fhtml'])."','".LMEscape_str($fr[fzs])."',$fr[isadd],$fr[isshow],$fr[iscj],'".LMEscape_str($fr[cjhtml])."',$fr[myorder],'$fr[ftype]','$fr[flen]',$fr[dotemp],\$tid,'\$tbname',$fr[savetxt],'".LMEscape_str($fr[fvalue])."',$fr[iskey],$fr[tobr],$fr[dohtml],'".LMEscape_str($fr[qfhtml])."',$fr[isonly],'".LMEscape_str($fr[linkfieldval])."',$fr[samedata],'$fr[fformsize]');\");
";
	}
	//模型
	$loadmod.="\$empire->query(\"insert into \".\$dbtbpre.\"enewsmod(mname,mtemp,mzs,cj,enter,tempvar,sonclass,searchvar,tid,tbname,qenter,mustqenterf,qmtemp,listandf,setandf,listtempvar,filef,imgf,flashf,qmname,canaddf,caneditf,dohtmlf,tobrf) values('$mr[mname]','".LMEscape_str($mr[mtemp])."','".LMEscape_str($mr[mzs])."','".LMEscape_str($mr[cj])."','".LMEscape_str($mr[enter])."','".LMEscape_str($mr[tempvar])."','','".LMEscape_str($mr[searchvar])."',\$tid,'\$tbname','".LMEscape_str($mr[qenter])."','".LMEscape_str($mr[mustqenterf])."','".LMEscape_str($mr[qmtemp])."','".LMEscape_str($mr[listandf])."',$mr[setandf],'".LMEscape_str($mr[listtempvar])."','".LMEscape_str($mr[filef])."','".LMEscape_str($mr[imgf])."','".LMEscape_str($mr[flashf])."','".LMEscape_str($mr[qmname])."','".LMEscape_str($mr[canaddf])."','".LMEscape_str($mr[caneditf])."','".LMEscape_str($mr[dohtmlf])."','".LMEscape_str($mr[tobrf])."');\");
\$mid=\$empire->lastid();
?>";
	$file=$tr['tbname'].time().".mod";
	$filepath="mod/".$file;
	WriteFiletext_n($filepath,$loadmod);
	DownLoadFile($file,$filepath,1);
	//操作日志
	insert_dolog("tid=$tid&tb=$tr[tbname]<br>mid=$mid&m=$mr[mname]");
	exit();
}

//返回数据表结构
function LoadModReturnstru($table,$tb,$ecms=0){
	global $empire;
	$usql=$empire->query("SET SQL_QUOTE_SHOW_CREATE=1;");//设置引号
	$r=$empire->fetch1("SHOW CREATE TABLE `$table`;");//数据表结构
	$create=str_replace("\"","\\\"",$r[1]);
	$create=LoadModToMysqlFour($create);
	//替换表
	if($ecms==1)
	{
		$reptb="\$dbtbpre.\"ecms_\".\$tbname.\"_doc\"";
	}
	elseif($ecms==2)
	{
		$reptb="\$dbtbpre.\"ecms_infoclass_\".\$tbname";
	}
	elseif($ecms==3)
	{
		$reptb="\$dbtbpre.\"ecms_infotmp_\".\$tbname";
	}
	else
	{
		$reptb="\$dbtbpre.\"ecms_\".\$tbname";
	}
	$dumpsql.="\$empire->query(str_replace(\"".$table."\",$reptb,SetCreateTable(\"".$create."\",\$phome_db_dbchar)));\r\n";
	return $dumpsql;
}

//转为Mysql4.0格式
function LoadModToMysqlFour($query){
	$exp="ENGINE=";
	if(!strstr($query,$exp))
	{
		return $query;
	}
	$exp1=" ";
	$r=explode($exp,$query);
	//取得表类型
	$r1=explode($exp1,$r[1]);
	$returnquery=$r[0]."TYPE=".$r1[0];
	return $returnquery;
}

//字符过虑
function LMEscape_str($str){
	$str=mysql_escape_string($str);
	$str=str_replace('\\\'','\'\'',$str);
	$str=str_replace("\\\\","\\\\\\\\",$str);
	$str=str_replace('$','\$',$str);
	return $str;
}

//增加封面模板
function AddClasstemp($add,$userid,$username){
	global $empire,$dbtbpre;
	if(!$add[tempname]||!$add[temptext])
	{
		printerror("EmptyClasstempname","history.go(-1)");
    }
	//验证权限
	CheckLevel($userid,$username,$classid,"template");
	$classid=(int)$add['classid'];
	$gid=(int)$add['gid'];
	$add[temptext]=RepPhpAspJspcode($add[temptext]);
	$sql=$empire->query("insert into ".GetDoTemptb("enewsclasstemp",$gid)."(tempname,temptext,classid) values('$add[tempname]','".addslashes($add[temptext])."',$classid);");
	if($sql)
	{
		$tempid=$empire->lastid();
		//操作日志
		insert_dolog("tempid=$tempid&tempname=$add[tempname]&gid=$gid");
		printerror("AddClasstempSuccess","AddClasstemp.php?enews=AddClasstemp&gid=$gid");
	}
	else
	{
		printerror("DbError","history.go(-1)");
	}
}

//修改封面模板
function EditClasstemp($add,$userid,$username){
	global $empire,$dbtbpre;
	$tempid=(int)$add['tempid'];
	if(!$tempid||!$add[tempname]||!$add[temptext])
	{
		printerror("EmptyClasstempname","history.go(-1)");
    }
	//验证权限
	CheckLevel($userid,$username,$classid,"template");
	$classid=(int)$add['classid'];
	$gid=(int)$add['gid'];
	$add[temptext]=RepPhpAspJspcode($add[temptext]);
	$sql=$empire->query("update ".GetDoTemptb("enewsclasstemp",$gid)." set tempname='$add[tempname]',temptext='".addslashes($add[temptext])."',classid=$classid where tempid=$tempid");
	if($sql)
	{
		//操作日志
		insert_dolog("tempid=$tempid&tempname=$add[tempname]&gid=$gid");
		printerror("EditClasstempSuccess","ListClasstemp.php?classid=$add[cid]&gid=$gid");
	}
	else
	{
		printerror("DbError","history.go(-1)");
	}
}

//删除封面模板
function DelClasstemp($add,$userid,$username){
	global $empire,$dbtbpre;
	$tempid=(int)$add['tempid'];
	if(!$tempid)
	{
		printerror("EmptyClasstempid","history.go(-1)");
    }
	//验证权限
	CheckLevel($userid,$username,$classid,"template");
	$gid=(int)$add['gid'];
	$r=$empire->fetch1("select tempname from ".GetDoTemptb("enewsclasstemp",$gid)." where tempid=$tempid");
	$sql=$empire->query("delete from ".GetDoTemptb("enewsclasstemp",$gid)." where tempid=$tempid");
	if($sql)
	{
		//操作日志
		insert_dolog("tempid=$tempid&tempname=$r[tempname]&gid=$gid");
		printerror("DelClasstempSuccess","ListClasstemp.php?classid=$add[cid]&gid=$gid");
	}
	else
	{
		printerror("DbError","history.go(-1)");
	}
}

//保存专题信息
function SaveTogZtInfo($add,$userid,$username){
	global $empire,$dbtbpre;
	if(!trim($add[togztname]))
	{
		printerror('EmptySaveTogZtname','history.go(-1)');
	}
	$add['doecmszt']=(int)$add['doecmszt'];
	$add[classid]=(int)$add[classid];
	//搜索字段
	$searchf=',';
	if($add[stitle]==1)
	{
		$searchf.='stitle,';
	}
	if($add[susername]==1)
	{
		$searchf.='susername,';
	}
	if($add[snewstext]==1)
	{
		$searchf.='snewstext,';
	}
	//特殊字段
	$specialsearch=',';
	if($add[isgood])
	{
		$specialsearch.='isgood,';
	}
	if($add[firsttitle])
	{
		$specialsearch.='firsttitle,';
	}
	if($add[titlepic])
	{
		$specialsearch.='titlepic,';
	}
	if($add[checked])
	{
		$specialsearch.='checked,';
	}
	$add['retype']=(int)$add['retype'];
	$add['startid']=(int)$add['startid'];
	$add['endid']=(int)$add['endid'];
	$add['pline']=(int)$add['pline'];
	$r=$empire->fetch1("select togid from {$dbtbpre}enewstogzts where togztname='$add[togztname]'");
	if($r[togid])
	{
		$sql=$empire->query("update {$dbtbpre}enewstogzts set keyboard='".addslashes($add[keyboard])."',searchf='$searchf',query='".addslashes($add[query])."',specialsearch='$specialsearch',classid=$add[classid],retype=$add[retype],startday='".addslashes($add[startday])."',endday='".addslashes($add[endday])."',startid=$add[startid],endid=$add[endid],pline=$add[pline],doecmszt=$add[doecmszt] where togid='$r[togid]'");
		$togid=$r[togid];
	}
	else
	{
		$sql=$empire->query("insert into {$dbtbpre}enewstogzts(keyboard,searchf,query,specialsearch,classid,retype,startday,endday,startid,endid,pline,doecmszt,togztname) values('".addslashes($add[keyboard])."','$searchf','".addslashes($add[query])."','$specialsearch',$add[classid],$add[retype],'".addslashes($add[startday])."','".addslashes($add[endday])."',$add[startid],$add[endid],$add[pline],$add[doecmszt],'".addslashes($add[togztname])."');");
		$togid=$empire->lastid();
	}
	if($sql)
	{
		insert_dolog("togid=$togid&togztname=$add[togztname]");//操作日志
		printerror("SaveTogZtInfoSuccess","TogZt.php?ztid=$add[ztid]&togid=$togid");
	}
	else
	{
		printerror("DbError","history.go(-1)");
	}
}

//删除保存专题信息
function DelTogZtInfo($add,$userid,$username){
	global $empire,$dbtbpre;
	$togid=intval($add[togid]);
	if(!$togid)
	{
		printerror('EmptyDelTogztid','history.go(-1)');
	}
	$r=$empire->fetch1("select togid,togztname from {$dbtbpre}enewstogzts where togid='$togid'");
	if(!$r[togid])
	{
		printerror('EmptyDelTogztid','history.go(-1)');
	}
	$sql=$empire->query("delete from {$dbtbpre}enewstogzts where togid='$togid'");
	if($sql)
	{
		insert_dolog("togid=$togid&togztname=$r[togztname]");//操作日志
		printerror('DelTogZtInfoSuccess',$_SERVER['HTTP_REFERER']);
	}
	else
	{
		printerror("DbError","history.go(-1)");
	}
}
?>